/* Enterprise Web Application Stack */import{TypeRegistry,Keygrip,AuthenticationError,ParameterError,WebApplication,WebApplicationSettings,conf,Exception,retry as retry$1,ApplicationError,IsNumber as IsNumber$1,Resolvable as Resolvable$1,service as service$1,singleton as singleton$1,middleware,WebController,method}from'@e2/web';import{model,property,MongoSymbols,MongoModel,MongoCollection,MongoDatabase,ObjectId,MongoClient,CreateIdString,CreateObjectId,IdStr,MongoAuditEvents,IsValidObjectId}from'@e2/mongodb';import{retry,Base62,Resolvable,BaseX,service,singleton,TypeRegistry as TypeRegistry$1}from'@e2/core';import{Root}from'protobufjs';import{IsNumber}from'agentframework';import{filter}from'lodash';import axios from'axios';import{createHash}from'crypto';import{create}from'simple-oauth2';import{stringify}from'querystring';import{resolve}from'url';const SYSTEM_MAX_UPLOAD_SIZE=15728640,SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER=1;/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */function __decorate(e,t,n,o){var s,p=arguments.length,a=3>p?t:null===o?o=Object.getOwnPropertyDescriptor(t,n):o;if('object'==typeof Reflect&&'function'==typeof Reflect.decorate)a=Reflect.decorate(e,t,n,o);else for(var y=e.length-1;0<=y;y--)(s=e[y])&&(a=(3>p?s(a):3<p?s(t,n,a):s(t,n))||a);return 3<p&&a&&Object.defineProperty(t,n,a),a}function __metadata(e,t){if('object'==typeof Reflect&&'function'==typeof Reflect.metadata)return Reflect.metadata(e,t)}let EdgeModel=class e extends MongoModel{collection(){return this[MongoSymbols.CollectionInstance]}};__decorate([property(),__metadata('design:type',String)],EdgeModel.prototype,'outType',void 0),__decorate([property(),__metadata('design:type',String)],EdgeModel.prototype,'label',void 0),__decorate([property(),__metadata('design:type',String)],EdgeModel.prototype,'inType',void 0),__decorate([property(),__metadata('design:type',Object)],EdgeModel.prototype,'outV',void 0),__decorate([property(),__metadata('design:type',Object)],EdgeModel.prototype,'inV',void 0),__decorate([property(),__metadata('design:type',Object)],EdgeModel.prototype,'meta',void 0),__decorate([property(),__metadata('design:type',Date)],EdgeModel.prototype,'expires',void 0),__decorate([property(),__metadata('design:type',Date)],EdgeModel.prototype,'createdAt',void 0),__decorate([property(),__metadata('design:type',String)],EdgeModel.prototype,'createdFrom',void 0),__decorate([property(),__metadata('design:type',Object)],EdgeModel.prototype,'createdBy',void 0),__decorate([property(),__metadata('design:type',Date)],EdgeModel.prototype,'updatedAt',void 0),__decorate([property(),__metadata('design:type',String)],EdgeModel.prototype,'updatedFrom',void 0),__decorate([property(),__metadata('design:type',Object)],EdgeModel.prototype,'updatedBy',void 0),EdgeModel=__decorate([model('edge')],EdgeModel);class Collection extends MongoCollection{}class EdgeCollection extends Collection{constructor(e){super(e,EdgeModel)}outV(e,t,i={},n={},o={}){return this.aggregation({filter:Object.assign(i,{outV:e,label:t}),lookup:{inV:t},projection:n,sort:o})}inV(e,t,i,n={},o={},d={}){return this.aggregation({filter:Object.assign(n,{inV:e,label:t}),lookup:{outV:i},projection:o,sort:d})}removeRelationships(e){return Promise.all([this.find({outV:e}).then(e=>e.results),this.find({inV:e}).then(e=>e.results)]).then(([e,t])=>e.length||t.length?this.deleteMany([...e,...t]):[])}static getIndices(){return[{name:'unique_relationship',key:{inV:1,inType:1,label:1,outV:1,outType:1},unique:!0},{name:'index_outV_outType_inV_inType',key:{outV:1,outType:1,inV:1,inType:1}},{name:'index_outV_outType_label_inType',key:{outV:1,outType:1,label:1,inType:1}},{name:'index_outV_outType_label',key:{outV:1,outType:1,label:1}},{name:'index_outV_outType_inType',key:{outV:1,outType:1,inType:1}},{name:'index_outV_outType',key:{outV:1,outType:1}},{name:'index_inV_inType_label_inType',key:{inV:1,inType:1,label:1,outType:1}},{name:'index_inV_inType_label',key:{inV:1,inType:1,label:1}},{name:'index_inV_inType_inType',key:{inV:1,inType:1,outType:1}},{name:'index_inV_inType',key:{inV:1,inType:1}},{name:'index_deleted',key:{deleted:1}},{name:'index_blocked',key:{blocked:1}}]}createIndices(){return super.createIndex(EdgeCollection.getIndices())}}let EdgeSymbolKey=Symbol.for('agentframework.mongodb.graph.edge');class VertexModel extends MongoModel{collection(){return this[MongoSymbols.CollectionInstance]}$edge(){const e=this[EdgeSymbolKey];return!!e&&e.label}addEdgeFrom(e,t,i={}){const n=this.collection().graph().collection(EdgeCollection),o={outType:t.getType(),label:e,inType:this.getType(),outV:t._id,inV:this._id,meta:i};return retry(()=>n.insertOne(o))}addEdgeTo(e,t,i={}){const n=this.collection().graph().collection(EdgeCollection),o={outType:this.getType(),label:e,inType:t.getType(),outV:this._id,inV:t._id,meta:i};return retry(()=>n.insertOne(o))}fetch(){return this.collection().findOneById(this._id).then(e=>{if(!e)throw new Error('unable to fetch current model object');return Object.assign(this,e),e})}findEdges(){const e=this.collection().graph().collection(EdgeCollection),t=this._id,i=this.getType();return e.find({$or:[{inV:t,inType:i},{outV:t,outType:i}]}).then(e=>e.results)}findOutEdges(){const e=this.collection().graph().collection(EdgeCollection),t=this._id,i=this.getType();return e.find({inV:t,inType:i}).then(e=>e.results)}findInEdges(){const e=this.collection().graph().collection(EdgeCollection),t=this._id,i=this.getType();return e.find({outV:t,outType:i}).then(e=>e.results)}findFromVertices(e,t){return this.findOutVertices(e,t)}findToVertices(e,t){return this.findInVertices(e,t)}findOutVertices(e,t){const i=this.collection().graph().collection(EdgeCollection),n=this._id,o=this.getType(),d=e.getType();return i.aggregation({filter:t?{inV:n,inType:o,label:t,outType:d}:{inV:n,inType:o,outType:d},lookup:{outV:d}}).then(t=>{const i=[];return t.forEach(t=>{const n=e.wrap(t.outV);n&&(Reflect.set(n,EdgeSymbolKey,t),i.push(n))}),i})}findInVertices(e,t){const i=this.collection().graph().collection(EdgeCollection),n=this._id,o=this.getType(),d=e.getType();return i.aggregation({filter:t?{outV:n,outType:o,label:t,inType:d}:{outV:n,outType:o,inType:d},lookup:{inV:d,outV:o}}).then(t=>{const i=[];return t.forEach(t=>{const n=e.wrap(t.inV);n&&(Reflect.set(n,EdgeSymbolKey,t),i.push(n))}),i})}findOutTypes(e){const t=this.collection().graph().collection(EdgeCollection),i=this._id,n=this.getType();return t.find({inV:i,inType:n,label:e}).then(e=>Array.from(new Set(e.results.map(e=>e.inType))))}findInTypes(e){const t=this.collection().graph().collection(EdgeCollection),i=this._id,n=this.getType();return t.find({outV:i,outType:n,label:e}).then(e=>Array.from(new Set(e.results.map(e=>e.inType))))}findOutLabels(e){const t=this.collection().graph().collection(EdgeCollection),i=this._id,n=this.getType(),o=e.getType();return t.find({inV:i,inType:n,outType:o}).then(e=>Array.from(new Set(e.results.map(e=>e.label))))}findInLabels(e){const t=this.collection().graph().collection(EdgeCollection),i=this._id,n=this.getType(),o=e.getType();return t.find({inV:i,inType:n,outType:o}).then(e=>Array.from(new Set(e.results.map(e=>e.label))))}}__decorate([property(),__metadata('design:type',Date)],VertexModel.prototype,'expires',void 0),__decorate([property(),__metadata('design:type',Date)],VertexModel.prototype,'createdAt',void 0),__decorate([property(),__metadata('design:type',String)],VertexModel.prototype,'createdFrom',void 0),__decorate([property(),__metadata('design:type',Object)],VertexModel.prototype,'createdBy',void 0),__decorate([property(),__metadata('design:type',Date)],VertexModel.prototype,'updatedAt',void 0),__decorate([property(),__metadata('design:type',String)],VertexModel.prototype,'updatedFrom',void 0),__decorate([property(),__metadata('design:type',Object)],VertexModel.prototype,'updatedBy',void 0);let UserModel=class e extends VertexModel{};UserModel=__decorate([model('user')],UserModel);class UserCollection extends Collection{constructor(e){super(e,UserModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(UserCollection.getIndices())}}class CurrentUser extends UserModel{static[TypeRegistry.Initializer](e,t){const i=t.identity.user;return'string'==typeof i?t.state.db.collection(UserCollection).findOneById(i).then(e=>(e&&Reflect.setPrototypeOf(e,CurrentUser.prototype),e)):null}}class WebIdentity{}class Graph extends MongoDatabase{constructor(e,t,i){super(e,t),this.identity=i?i.identity:t.identity}audit(e,t={},i){return'boolean'==typeof i&&(t[''+e]=i),t[''+e+'At']=new Date,t[''+e+'From']=this.identity.address,t[''+e+'By']=this.identity.profile,t}}class SecuredCookie extends Resolvable{constructor(e){super(e),this.crypts=new Keygrip(e.settings.WEBAPP_SESSION_COOKIE_SECRET,'sha1'),this.base72=new BaseX('0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ:/?&=.-,@%')}sign(e){const t=this.crypts.sign(e);return Base62.fromBuffer(this.base72.toBuffer(e))+'.'+Base62.fromBuffer(t)}verify(e){try{const t=e.split('.'),i=this.base72.fromBuffer(Base62.toBuffer(t[0])),n=Base62.toBuffer(t[1]);return!!this.crypts.verify(i,n)&&i}catch(e){return console.log('verify key error',e),!1}}}let SessionCookieManager=class e extends Resolvable{get(e){const t=e.cookies.get(e.settings.WEBAPP_SESSION_COOKIE_KEY);if(t){const i=this.security.verify(t);if(i)return i;e.logger.warn({fingerprint:e.fingerprint(),cookie:t},'[INTRUSION DETECTED] User sent invalidate auth token:')}return null}set(e,t){const i={path:e.settings.WEBAPP_SESSION_COOKIE_PATH,httpOnly:!0,maxAge:e.settings.WEBAPP_SESSION_COOKIE_EXPIRES_IN_SECONDS,secure:e.settings.WEBAPP_SESSION_COOKIE_SECURED,overwrite:!0};e.settings.WEBAPP_SESSION_COOKIE_EXPIRES_IN_SECONDS||delete i.maxAge,e.cookies.set(e.settings.WEBAPP_SESSION_COOKIE_KEY,this.security.sign(t),i)}clear(e){const t={path:e.settings.WEBAPP_SESSION_COOKIE_PATH,httpOnly:!0,maxAge:1,expires:new Date(2013,1,1),secure:e.settings.WEBAPP_SESSION_COOKIE_SECURED,overwrite:!0};e.cookies.set(e.settings.WEBAPP_SESSION_COOKIE_KEY,'',t)}};__decorate([singleton(),__metadata('design:type',SecuredCookie)],SessionCookieManager.prototype,'security',void 0),SessionCookieManager=__decorate([service()],SessionCookieManager);class SessionProtocol{static[TypeRegistry$1.Singleton](){return Root.fromJSON({nested:{IdentityProfile:{fields:{_id:{type:'bytes',id:1},displayName:{type:'string',id:2},displayImageURL:{type:'string',id:3}}},WebSession:{fields:{session:{type:'bytes',id:1},user:{type:'bytes',id:2},token:{type:'bytes',id:3},roles:{type:'string',rule:'repeated',id:4},groups:{type:'string',rule:'repeated',id:5},scope:{type:'string',rule:'repeated',id:6},profile:{type:'IdentityProfile',id:7}}}}}).lookupType('WebSession')}static get schema(){const e=this[TypeRegistry$1.Singleton];if(e){const e=this[TypeRegistry$1.Singleton]();return Reflect.defineProperty(this,'schema',{value:e}),e}throw new Error('TypeRegistry.Singleton is not found')}}class SessionScheme extends SessionProtocol{static encode(e){const t=Object.assign({},e);if(e.session instanceof ObjectId&&(t.session=e.session.id),e.user instanceof ObjectId&&(t.user=e.user.id),e.token instanceof ObjectId&&(t.token=e.token.id),e.token instanceof ObjectId&&(t.token=e.token.id),e.profile){let i;i=e.profile._id instanceof ObjectId?e.profile._id.id:'string'==typeof e.profile._id?Buffer.from(e.profile._id,'hex'):new Buffer(0),t.profile={_id:i,displayName:e.profile.displayName,displayImageURL:e.profile.displayImageURL}}return new Buffer(this.schema.encode(t).finish())}static decode(e){const t=this.schema.decode(e);Buffer.isBuffer(t.session)&&(t.session=new ObjectId(t.session)),Buffer.isBuffer(t.user)&&(t.user=new ObjectId(t.user)),Buffer.isBuffer(t.token)&&(t.token=new ObjectId(t.token));const i=t.profile;if(i){let e;e=Buffer.isBuffer(i._id)?new ObjectId(i._id):null,t.profile={_id:e,displayName:i.displayName,displayImageURL:i.displayImageURL}}return t}}let WebIdentityService=class e extends Resolvable{get name(){return'WebIdentityService'}create(e,t){const i=this.sessionCookie.get(e);return i&&i.length?SessionScheme.decode(Base62.toBuffer(i)):{}}update(e,t){const i=Object.keys(t);if(!i.length)throw new ParameterError('Unable to update empty identity, please use WebIdentityService.clear() instead');const n=SessionScheme.encode(t);if(!n||!n.byteLength)throw new AuthenticationError('Invalid session data (byteLength=0)');console.log('got data',Base62.fromBuffer(n).length),this.sessionCookie.set(e,Base62.fromBuffer(n))}clear(e){for(const t of Object.keys(e.identity))'id'!==t&&'address'!==t&&delete e.identity[t];this.sessionCookie.clear(e)}};__decorate([singleton(),__metadata('design:type',SessionCookieManager)],WebIdentityService.prototype,'sessionCookie',void 0),WebIdentityService=__decorate([service()],WebIdentityService);class WebFoundationApplication extends WebApplication{createRequestState(e,t){return Object.create(Object.create(this.state))}createRequestIdentity(e,t,i){const n=new WebIdentity;return n.id=t,n.address=i,Object.assign(n,this.WebIdentityService.create(e)),n}onInitApplication(){if(this.settings.MONGODB_URL&&(this.addGlobalType(MongoClient),this.addType(MongoClient),this.addType(Graph),this.addType(CurrentUser),Array.isArray(this.settings.OIDC_PROVIDERS)&&this.settings.OIDC_PROVIDERS.length));this.resolve(WebIdentityService).then(e=>{this.WebIdentityService=e},e=>{this.exit(e)})}}class WebFoundationApplicationSettings extends WebApplicationSettings{constructor(){super(...arguments),this.ADMIN_EMAIL='',this.MONGODB_URL='',this.MONGODB_DATABASE='',this.MONGODB_EVENT_LOG_LEVEL='',this.WEBAPP_SESSION_COOKIE_PATH='/api',this.WEBAPP_SESSION_COOKIE_KEY='y',this.WEBAPP_SESSION_COOKIE_SECRET=['1234567890abcdefgh'],this.WEBAPP_SESSION_COOKIE_SECURED=!1,this.WEBAPP_SESSION_COOKIE_EXPIRES_IN_SECONDS=0,this.WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEBAPP_TOKEN_EXPIRES_IN_MILLISECONDS=3e4,this.WEBAPP_INVITATION_EXPIRES_IN_MILLISECONDS=12096e5,this.WEBAPP_EMAIL_VERIFICATION_RESEND_COOLDOWN_IN_MILLISECONDS=6e4,this.WEBAPP_EMAIL_VERIFICATION_EXPIRES_IN_MILLISECONDS=216e5,this.WEBAPP_LOGIN_PATH='/api/user/signin',this.WEBAPP_LOGIN_SUCCESS_PATH='',this.WEBAPP_LOGIN_FAILED_PATH='',this.WEBAPP_LOGOUT_PATH='/api/user/signout',this.WEBAPP_LOGOUT_COMPLETE_PATH='',this.MAX_NUMBER_OF_ACCOUNTS_PER_USER=SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER,this.MAX_UPLOAD_SIZE=SYSTEM_MAX_UPLOAD_SIZE}}__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'ADMIN_EMAIL',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'MONGODB_URL',void 0),__decorate([conf(),__metadata('design:type',Object)],WebFoundationApplicationSettings.prototype,'MONGODB_DATABASE',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'MONGODB_EVENT_LOG_LEVEL',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_PATH',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_KEY',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_SECRET',void 0),__decorate([conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_SECURED',void 0),__decorate([conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_EXPIRES_IN_SECONDS',void 0),__decorate([conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS',void 0),__decorate([conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_TOKEN_EXPIRES_IN_MILLISECONDS',void 0),__decorate([conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_INVITATION_EXPIRES_IN_MILLISECONDS',void 0),__decorate([conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_EMAIL_VERIFICATION_RESEND_COOLDOWN_IN_MILLISECONDS',void 0),__decorate([conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_EMAIL_VERIFICATION_EXPIRES_IN_MILLISECONDS',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGIN_PATH',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGIN_SUCCESS_PATH',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGIN_FAILED_PATH',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGOUT_PATH',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGOUT_COMPLETE_PATH',void 0),__decorate([conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'MAX_NUMBER_OF_ACCOUNTS_PER_USER',void 0),__decorate([conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'MAX_UPLOAD_SIZE',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'JDK_ACCESS_KEY',void 0),__decorate([conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'OAUTH_AUTHENTICATION_EXPIRES_IN_MILLISECONDS',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_REDIRECT_LIST',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_NO_REDIRECTS_LIST',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OIDC_PROVIDERS',void 0),__decorate([conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_GOOGLE',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GOOGLE_CLIENT_ID',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GOOGLE_CLIENT_SECRET',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_GOOGLE_SCOPE',void 0),__decorate([conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_TENANT_ID',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_CLIENT_ID',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_CLIENT_SECRET',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_BASE_URL',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_SCOPE',void 0),__decorate([conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB_CLIENT_ID',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB_CLIENT_SECRET',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB_BASE_URL',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB_SCOPE',void 0),__decorate([conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_GITHUB',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITHUB_CLIENT_ID',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITHUB_CLIENT_SECRET',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_GITHUB_SCOPE',void 0),__decorate([conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_WEIBO',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_WEIBO_CLIENT_ID',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_WEIBO_CLIENT_SECRET',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_WEIBO_SCOPE',void 0),__decorate([conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_WECHAT',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_WECHAT_CLIENT_ID',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_WECHAT_CLIENT_SECRET',void 0),__decorate([conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_WECHAT_SCOPE',void 0),__decorate([conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM_BOT_ID',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM_BOT_SECRET',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM_BOT_TOKEN',void 0),__decorate([conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM_PAYMENT_TOKEN',void 0);let EmailModel=class e extends VertexModel{};EmailModel=__decorate([model('email')],EmailModel);class EmailCollection extends Collection{constructor(e){super(e,EmailModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(EmailCollection.getIndices())}}let ExternalUserModel=class e extends VertexModel{};__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'uid',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'provider',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'providerProtocol',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'providerData',void 0),__decorate([property(),__metadata('design:type',Array)],ExternalUserModel.prototype,'identities',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'user',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'username',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'domain',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'email',void 0),__decorate([property(),__metadata('design:type',Boolean)],ExternalUserModel.prototype,'emailCertified',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'mobile',void 0),__decorate([property(),__metadata('design:type',Boolean)],ExternalUserModel.prototype,'mobileCertified',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'displayName',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'displayImageURL',void 0),__decorate([property(),__metadata('design:type',ObjectId)],ExternalUserModel.prototype,'displayImageFile',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'familyName',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'givenName',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'gender',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'dob',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'status',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'bio',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'homepage',void 0),__decorate([property(),__metadata('design:type',Boolean)],ExternalUserModel.prototype,'blocked',void 0),__decorate([property(),__metadata('design:type',Date)],ExternalUserModel.prototype,'blockedAt',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'blockedFrom',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'blockedBy',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'blockedReason',void 0),__decorate([property(),__metadata('design:type',Boolean)],ExternalUserModel.prototype,'deleted',void 0),__decorate([property(),__metadata('design:type',Date)],ExternalUserModel.prototype,'deletedAt',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'deletedFrom',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'deletedBy',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'deletedReason',void 0),ExternalUserModel=__decorate([model('external_user')],ExternalUserModel);class ExternalUserCollection extends Collection{constructor(e){super(e,ExternalUserModel)}static getIndices(){return[{name:'unique_external_user',key:{provider:1,providerProtocol:1,uid:1},unique:!0},{name:'index_provider',key:{provider:1}},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(ExternalUserCollection.getIndices())}}let SessionModel=class e extends VertexModel{};SessionModel=__decorate([model('session')],SessionModel);class SessionCollection extends Collection{constructor(e){super(e,SessionModel)}}class ExternalUserMutations{static async FindExternalUser(e,t){const i=e.collection(ExternalUserCollection),n={provider:t.provider+'',providerProtocol:t.providerProtocol+'',uid:IsNumber(t.uid)?+t.uid:t.uid+''};return i.findOne(n)}static async FindOrCreateExternalUser(e,t){const i=e.collection(ExternalUserCollection),n={provider:t.provider+'',providerProtocol:t.providerProtocol+'',uid:IsNumber(t.uid)?+t.uid:t.uid+''};return i.findOneAndUpsert(n,{$set:t}).then(e=>{if(!e)throw new Error('Unable to create external user');return e})}}const lodash=require('lodash');class SessionMutations{static async CreateSession(e,t,i,n,o,d){const s=CreateObjectId(),r={user:t._id,device:e.identity.id,roles:lodash.intersection(t.roles,i),expires:new Date(Date.now()+e.settings.WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS),token:s,tokens:[{token:s,context:n}]};o&&(r.previous=o._id.toString(),d&&(r.impersonated=!0,r.impersonatedAt=new Date));const p=e.collection(SessionCollection);return retry$1(()=>p.insertOne(r)).then(e=>{if(!e)throw new AuthenticationError('unable to create session');return e})}static async CreateOrUpdateSession(e,t,i,n,o){const d=CreateIdString(),s=await e.resolve(Graph),r=s.collection(SessionCollection);return r.findOneAndUpdate({_id:CreateObjectId(e.identity.id)},{$set:{user:IdStr(t),device:e.identity.id,account:n,roles:lodash.intersection(t.roles,i),token:d,expires:new Date(Date.now()+31536000000)},$push:{tokens:{token:d,context:o}}}).then(s=>s?s:r.insertOne({_id:CreateObjectId(e.identity.id),user:IdStr(t),device:e.identity.id,account:n,roles:lodash.intersection(t.roles,i),expires:new Date(Date.now()+31536000000),token:d,tokens:[{token:d,context:o}]}))}static async ExtendSession(e,t){const i=CreateIdString(),n=e.identity,o=e.collection(SessionCollection);return null===typeof n.session?Promise.reject(new AuthenticationError('Unable to extend null session')):o.findOneAndUpdate({_id:n.session,device:n.id,user:n.user,token:n.token,expires:{$gt:new Date},deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{token:i,expires:new Date(Date.now()+e.settings.WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS)},$push:{tokens:{token:i,context:t}}},{tokens:0}).then(e=>e?e:o.findOne({_id:n.session,device:n.id,user:n.user,tokens:{$elemMatch:{token:n.token}},expires:{$gt:new Date},deleted:{$ne:!0},blocked:{$ne:!0}},{tokens:0}).then(e=>{if(!e)throw new AuthenticationError('extended session not found');return e}))}static async RestoreSession(e,t,i,n){const o=CreateIdString(),d=e.identity,s=e.settings.WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS,r=await e.resolve(Graph),p=r.collection(SessionCollection);return p.findOneAndUpdate({_id:t._id.toString(),device:d.id,deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{token:o,expires:new Date(Date.now()+s)},$push:{tokens:{token:o,context:i,restoreReason:n}}},{tokens:0})}static async TerminateSession(e,t){const i=e.identity;if(!i.session)return Promise.resolve(null);const n=await e.resolve(Graph),o=n.collection(SessionCollection);return o.findOneAndAudit({_id:CreateObjectId(i.session),user:i.user,device:i.id},MongoAuditEvents.Deleted,!0,{$set:{deletedReason:t}},{tokens:0}).then(e=>e,e=>{throw new Exception(e,`Error during terminate user session, need manual update session '${i.session}.exited' to 'true'`)})}}function Audit(e,t,i={},n){return'boolean'==typeof n&&(i[''+t]=n),i[''+t+'At']=new Date,i[''+t+'From']=e.address||null,i[''+t+'By']=e.profile||null,i}class EmailMutations{static async CreateEmailFromExternalUser(e,t){if(!t.user)throw new AuthenticationError(`Unable to create email for external user ${t._id} without user account linked`);if(!t.email)throw new AuthenticationError(`Unable to create email for external user ${t._id} without a valid email address`);if(!t.emailCertified)throw new AuthenticationError(`Unable to create email for external user ${t._id} without a certified email address`);const i=Audit(e.identity,'verified',{name:t.email,displayName:t.displayName,user:t.user}),n=e.collection(EmailCollection);return n.insertOne(i)}}class UserMutations{static async FindOrCreateFromExternalUser(e,t){const i=e.collection(UserCollection);return t.user?i.findOneById(t.user).then(e=>{if(!e)throw new AuthenticationError(`External user ${t._id.toString()} connected to an non-exists user`);return e}):UserMutations.CreateFromExternalUser(e,t)}static async CreateFromExternalUser(e,t){const i=e.settings,n={displayName:t.displayName,displayImageURL:t.displayImageURL,roles:['user'],settings:{MAX_NUMBER_OF_ACCOUNTS_PER_USER:i.MAX_NUMBER_OF_ACCOUNTS_PER_USER,MAX_UPLOAD_SIZE:i.MAX_UPLOAD_SIZE}};t.emailCertified&&i.ADMIN_EMAIL&&i.ADMIN_EMAIL===t.email&&n.roles.push('admin');const o=await e.resolve(Graph),d=o.collection(UserCollection),s=o.collection(ExternalUserCollection);return d.insertOne(n).then(i=>{if(!i)throw new ApplicationError('Unable to create user');return s.findOneAndUpdate({_id:t._id},{$set:{user:i._id}}).then(n=>{if(!n)throw new ApplicationError(`Unable to update external user ${t._id} with new created user. Need delete user ${i._id}`);return n.email&&n.emailCertified?EmailMutations.CreateEmailFromExternalUser(e,n).then(()=>i,()=>i):i})})}static async FindOrCreateFromEmail(e,t){const i=e.collection(UserCollection);return i.findOneById(t.user).then(i=>i?i:UserMutations.CreateFromEmail(e,t))}static async CreateFromEmail(e,t){if(!t.verified)throw new AuthenticationError(`Not allow to create user with unverified email: ${t.name}`);if(t.user)throw new AuthenticationError(`Not allow to create another user for same email: ${t.name}`);const i=e.settings,n={displayName:t.displayName,roles:['user'],settings:{MAX_NUMBER_OF_ACCOUNTS_PER_USER:i.MAX_NUMBER_OF_ACCOUNTS_PER_USER,MAX_UPLOAD_SIZE:i.MAX_UPLOAD_SIZE},identities:{email:t.name}};i.ADMIN_EMAIL&&i.ADMIN_EMAIL.length&&!!~i.ADMIN_EMAIL.indexOf(t.name)&&n.roles.push('admin');const o=await e.resolve(Graph),d=o.collection(UserCollection),s=o.collection(EmailCollection);return d.insertOne(n).then(e=>{if(!e)throw new ApplicationError('Unable to create user from email '+t.name);return s.findOneAndUpdate({_id:t._id},{$set:{user:e._id}}).then(t=>{if(!t)throw new AuthenticationError('Unable to update email with new created user, need manual delete user '+e._id.toString());return e})})}static async Update(e,t,i){const n=e.collection(UserCollection);return n.findOneAndUpdate({_id:t._id},{$set:i})}}class ExternalUserGetters{static FindExternalUser(e,t){const i={provider:`${t.provider}`,providerProtocol:`${t.providerProtocol}`,uid:IsNumber$1(t.uid)?t.uid:t.uid+''},n=e.collection(ExternalUserCollection);return n.findOne(i)}}class SessionGetters{static async GetUserById(e,t){const i=e.collection(UserCollection);return i.findOne({_id:CreateObjectId(t)})}static async GetExternalUserFromUser(e,t,i,n){const o=e.collection(ExternalUserCollection);return t.findOutVertices(o,'created').then(e=>{const t=filter(e,{provider:i,providerProtocol:n});if(t&&t.length){const e=t[0];return e}return null})}}class UserGetters{static async GetUserById(e,t){const i=e.collection(UserCollection);return i.findOne({_id:CreateObjectId(t)})}static async GetExternalUserFromUser(e,t,i,n){const o=e.collection(ExternalUserCollection);return t.findOutVertices(o,'created').then(e=>{const t=filter(e,{provider:i,providerProtocol:n});if(t&&t.length){const e=t[0];return e}return null})}}class RestClient{constructor(e={}){this.defaults=e}makeAxiosOptions(e){const t=Object.assign({},this.defaults,e||{}),i={};return t.headers&&(i.headers=t.headers),t.query&&(i.params=t.query),t.responseType&&(i.responseType=t.responseType),i}post(e,t,i){return axios.post(e,t,this.makeAxiosOptions(i)).then(e=>e.data)}postBuffer(e,t,i){return this.post(e,t,Object.assign({responseType:'arraybuffer'},i||{}))}put(e,t,i){return axios.put(e,t,this.makeAxiosOptions(i)).then(e=>e.data)}putBuffer(e,t,i={}){return this.put(e,t,Object.assign({responseType:'arraybuffer'},i||{}))}get(e,t={}){return axios.get(e,this.makeAxiosOptions(t)).then(e=>e.data)}getBuffer(e,t={}){return this.get(e,Object.assign({responseType:'arraybuffer'},t||{}))}delete(e,t={}){return axios.delete(e,this.makeAxiosOptions(t)).then(e=>e.data)}deleteBuffer(e,t={}){return this.delete(e,Object.assign({responseType:'arraybuffer'},t||{}))}}class MicrosoftClient extends RestClient{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error('Access token can not be null or empty')}profile(){return this.get('https://graph.microsoft.com/v1.0/me')}photo(){return this.get('https://graph.microsoft.com/v1.0/me/photo').catch(e=>{const t=e.response.status;if(404===t||501===t)return null;throw console.log(e.response.status,e.response.statusText,e.response.data),new Exception(e,e.response.data,'Unable to resolve user photo')})}photoImage(e){return this.getBuffer(`https://graph.microsoft.com/v1.0/me/photos/${e}/$value`)}photoImageURL(){return this.photo().then(e=>{if(!e)return Promise.resolve(null);const t=e['@odata.mediaContentType'],i=e.id;return this.photoImage(i).then(e=>`data:${t};charset=utf-8;base64,${e.toString('base64')}`)})}users(){return this.get(`https://graph.microsoft.com/v1.0/users`)}}const FileNamePathMatcher=/^(\/.+)\/([^/]+)$/;class JdkClient extends RestClient{constructor(e){super({headers:{"x-api-key":`Bearer ${e}`}}),this.access_token=e}uploadFile(e,t,i){const n=e.match(FileNamePathMatcher);if(!n)throw new TypeError(`Invalid filename ${e}`);const o=n[1],d=n[2];return this.post(`https://res.jsonsdk.com/api/upload/file/${this.access_token}${o}`,{name:d,type:i,data:t.toString('base64')}).then(e=>{if(e.ok)return e.result.notValidBefore=new Date(e.result.notValidBefore),e.result.notValidAfter=new Date(e.result.notValidAfter),e.result.createdAt=new Date(e.result.createdAt),e.result;throw new Error('Unable to upload file: '+e.message)})}}let FileModel=class e extends VertexModel{};__decorate([property(),__metadata('design:type',String)],FileModel.prototype,'path',void 0),__decorate([property(),__metadata('design:type',String)],FileModel.prototype,'name',void 0),__decorate([property(),__metadata('design:type',String)],FileModel.prototype,'originalname',void 0),__decorate([property(),__metadata('design:type',String)],FileModel.prototype,'type',void 0),__decorate([property(),__metadata('design:type',Number)],FileModel.prototype,'size',void 0),__decorate([property(),__metadata('design:type',Object)],FileModel.prototype,'hash',void 0),__decorate([property(),__metadata('design:type',Array)],FileModel.prototype,'chunks',void 0),__decorate([property(),__metadata('design:type',Object)],FileModel.prototype,'context',void 0),__decorate([property(),__metadata('design:type',Object)],FileModel.prototype,'stats',void 0),__decorate([property(),__metadata('design:type',Array)],FileModel.prototype,'tokens',void 0),__decorate([property(),__metadata('design:type',Date)],FileModel.prototype,'expires',void 0),__decorate([property(),__metadata('design:type',Date)],FileModel.prototype,'createdAt',void 0),__decorate([property(),__metadata('design:type',String)],FileModel.prototype,'createdFrom',void 0),__decorate([property(),__metadata('design:type',Object)],FileModel.prototype,'createdBy',void 0),FileModel=__decorate([model('file')],FileModel);class FileCollection extends Collection{constructor(e){super(e,FileModel)}static getIndices(){return[{name:'unique_file',key:{path:1,name:1},unique:!0}]}createIndices(){return super.createIndex(FileCollection.getIndices())}}let FileChunkModel=class e extends VertexModel{};__decorate([property(),__metadata('design:type',Object)],FileChunkModel.prototype,'hash',void 0),__decorate([property(),__metadata('design:type',String)],FileChunkModel.prototype,'type',void 0),__decorate([property(),__metadata('design:type',Number)],FileChunkModel.prototype,'size',void 0),__decorate([property(),__metadata('design:type',Number)],FileChunkModel.prototype,'offset',void 0),__decorate([property(),__metadata('design:type',Number)],FileChunkModel.prototype,'length',void 0),__decorate([property(),__metadata('design:type',Buffer)],FileChunkModel.prototype,'data',void 0),__decorate([property(),__metadata('design:type',Number)],FileChunkModel.prototype,'dataSize',void 0),__decorate([property(),__metadata('design:type',String)],FileChunkModel.prototype,'dataEncoding',void 0),__decorate([property(),__metadata('design:type',Date)],FileChunkModel.prototype,'expires',void 0),__decorate([property(),__metadata('design:type',Date)],FileChunkModel.prototype,'createdAt',void 0),__decorate([property(),__metadata('design:type',String)],FileChunkModel.prototype,'createdFrom',void 0),__decorate([property(),__metadata('design:type',Object)],FileChunkModel.prototype,'createdBy',void 0),FileChunkModel=__decorate([model('file_chunk')],FileChunkModel);class FileChunkCollection extends Collection{constructor(e){super(e,FileChunkModel)}static getIndices(){return[{name:'unique_chunk',key:{"hash.md5":1,"hash.sha1":1,"hash.sha256":1,"hash.ipfs":1},unique:!0,sparse:!0},{name:'index_hash_1',key:{"hash.md5":'hashed'}},{name:'index_hash_2',key:{"hash.sha1":'hashed'}},{name:'index_hash_3',key:{"hash.sha256":'hashed'}},{name:'index_hash_4',key:{"hash.ipfs":'hashed'}}]}createIndices(){return super.createIndex(FileChunkCollection.getIndices())}}let FileService=class e extends Resolvable$1{constructor(){super(...arguments),this.jdk=new JdkClient(this.settings.JDK_ACCESS_KEY)}enabled(){return!!this.settings.JDK_ACCESS_KEY}upload(e,t,i){return this.jdk.uploadFile(e,t,i)}async save(e,t,i,n,o,d=!1,s='untitled.file'){const r=t.byteLength;if(r>this.settings.MAX_UPLOAD_SIZE)throw new ParameterError('Buffer size over system limit');const p=e.collection(FileCollection),a=await p.findOne({path:n,name:o},{size:1,createdAt:1});if(a&&!d)throw new Error(`File ${n}/${o} already exists since ${a.createdAt.toISOString()} with size: ${a.size}`);const y=createHash('md5'),l=createHash('sha1'),_=createHash('sha256');y.update(t),l.update(t),_.update(t);const g=y.digest('hex'),u=l.digest('hex'),c=_.digest('hex'),E=e.collection(FileChunkCollection),{results:O}=await E.find({hash:{md5:g,sha1:u,sha256:c}},{offset:1,length:1,dataSize:1});if(!O.length){const e=await E.insertOne({hash:{md5:g,sha1:u,sha256:c},type:i,size:r,offset:0,length:r,data:t,dataSize:r,dataEncoding:'binary'});e&&O.push(e)}if(!O.length)throw new Error('unable to find or save file chunk');return p.findOneAndUpsert({path:n,name:o},{$setOnInsert:{path:n,name:o,stats:{view:0,download:0},tokens:[],context:null},$set:{originalname:s,type:i,size:r,hash:{md5:g,sha1:u,sha256:c},chunks:O.map(e=>({_id:e._id,offset:e.offset,length:e.length}))}}).then(e=>{if(!e)throw new Error('unable to save file');const t=e._id.toString();return{_id:e._id,id:t,url:'file://'+e.path+'/'+e.name,path:e.path,name:e.name||e.originalname,type:e.type,size:e.size,md5:e.hash.md5,sha1:e.hash.sha1,sha256:e.hash.sha256,createdAt:e.createdAt}})}async metadata(e,t){if(!IsValidObjectId(t))throw new ParameterError('Invalid id parameter');const i=await e.collection(FileCollection);return i.findOneAndUpdate({_id:CreateObjectId(t)},{$inc:{"stats.view":1}},{path:1,name:1,originalname:1,type:1,hash:1,size:1,dataSize:1,stats:1,expires:1,createdAt:1})}async content(e,t,i){if(!IsValidObjectId(t))throw new ParameterError('Invalid id parameter');if(!IsValidObjectId(i))throw new ParameterError('Invalid token parameter');const n=await e.collection(FileCollection);return n.findOneAndUpdate({_id:CreateObjectId(t),"tokens.token":CreateObjectId(i)},{$inc:{"stats.download":1}},{path:1,name:1,originalname:1,type:1,hash:1,size:1,dataSize:1,data:1,dataEncoding:1,stats:1,expires:1,createdAt:1})}};FileService=__decorate([service()],FileService);class InternalSymbol{}InternalSymbol.ServiceContext=Symbol('WfCtx');class WebFoundationUserService extends Resolvable$1{constructor(e,t){if(!t)throw new Error('User scoped service only can be created using ctx.resolve()');super(e),this[InternalSymbol.ServiceContext]=t}get domain(){const e=this[InternalSymbol.ServiceContext];return Reflect.defineProperty(this,'domain',{value:e.domain}),e.domain}addResponseHeader(e,t){this[InternalSymbol.ServiceContext].res.headers.append(e,t)}getRequestHeader(e){return this[InternalSymbol.ServiceContext].req.headers[e]}}let MicrosoftAuthenticator=class e extends WebFoundationUserService{constructor(){super(...arguments),this.certifiedEmails=['outlook.com','hotmail.com','live.com','msn.com','passport.com','passport.net']}init(e){const t=e.tenantId||'common';this.oauth=create({client:{id:e.clientId,secret:e.clientSecret},auth:{tokenHost:'https://login.microsoftonline.com',tokenPath:`${t}/oauth2/v2.0/token`,authorizePath:`${t}/oauth2/v2.0/authorize`}}),this.scope=Array.isArray(e.scope)?e.scope.join(' '):'openid email profile offline_access'}getAuthorizeURL(e,t){return this.oauth.authorizationCode.authorizeURL({redirect_uri:e,scope:this.scope,state:t+''})}getSuccessURL(e){return'/'}getFailureURL(e){return'/'}getToken(e,t){return this.oauth.authorizationCode.getToken({redirect_uri:e,scope:this.scope,code:t}).then(e=>{try{if(e.id_token){const t=e.id_token.split('.'),i=Buffer.from(t[1],'base64');e.id_token=JSON.parse(i.toString())}else e.id_token={},e.id_token_error='id_token is not found'}catch(t){e.id_token_error=t.message}return e})}async refreshToken(e){return this.oauth.accessToken.create(e).refresh()}async getProfile(e){const t=new MicrosoftClient(e.access_token),i=e.id_token,n=await t.profile();let o=null;const d=await t.photo().then(e=>{if(!e)return null;const i=e['@odata.mediaContentType'],o=e.id;return t.photoImage(o).then(e=>this.FileService.enabled()?this.FileService.upload('/user/profile/microsoft/'+n.id,e,i):this.FileService.save(this.domain,e,i,'/External/Microsoft/ProfileImages',n.id,!0))});o=d&&d.url?d.url:null;let s=[],r=null,p=null,a=null,y=!1;if(i.email?r=i.email:n.mail&&(r=n.mail),n.userPrincipalName&&!r&&(r=n.userPrincipalName),r){const e=r.split('@');2===e.length&&(p=e[0],a=e[1],0<=this.certifiedEmails.indexOf(a)&&(y=!0))}return r&&y&&s.push({type:'email',value:r}),{uid:n.id,provider:'microsoft',providerProtocol:'oauth2',providerData:e,identities:s,username:p,domain:a,email:r,emailCertified:y,mobile:n.mobilePhone,mobileCertified:!1,displayName:n.displayName,displayImageURL:o,familyName:n.surname,givenName:n.givenName,gender:null,dob:null,status:null,bio:null,homepage:null,locale:n.preferredLanguage}}};__decorate([singleton$1(),__metadata('design:type',FileService)],MicrosoftAuthenticator.prototype,'FileService',void 0),MicrosoftAuthenticator=__decorate([service$1()],MicrosoftAuthenticator);let SessionService=class e extends Resolvable$1{async Terminate(e,t){return SessionMutations.TerminateSession(e,t).then(t=>(t||e.warn({identity:{user:e.identity.user,session:e.identity.session}},`SessionService.terminate(): Session not found or already terminated`),t),t=>(e.error(t),null))}async CreateNew(e,t,i,n,o,d){return this.throwErrorForInvalidUser(t),SessionMutations.CreateSession(e,t,n,i,o,d)}throwErrorForInvalidUser(e){if(!e)throw new AuthenticationError('user not found');else if(e.deleted)throw new AuthenticationError(`user has been deleted at ${e.deletedAt}`);else if(e.blocked)throw new AuthenticationError(`user has been blocked at ${e.blockedAt}`)}throwErrorForInvalidSession(e){if(!e)throw new AuthenticationError('session not found');else if(e.deleted)throw new AuthenticationError(`session has been deleted at ${e.deletedAt}`);else if(e.blocked)throw new AuthenticationError(`session has been blocked at ${e.blockedAt}`);else if(e.expires<new Date)throw new AuthenticationError(`session has been expired at ${e.expires}`)}};SessionService=__decorate([service$1()],SessionService);let WebAuthenticationService=class e extends Resolvable$1{async Login(e,t,i=['user','admin']){const n=e.identity,o=e.domain,d=e.fingerprint();if(!n.id)throw new Error('Cookies is required for user authentication');let s;if(n.session){const n=await this.SessionService.Terminate(o,'new login');n&&(e.logger.debug({session:n._id},'Automatically logged out previous session for new user login'),s=await this.SessionService.CreateNew(o,t,d,i,n))}return s||(s=await this.SessionService.CreateNew(o,t,d,i)),this.updateWebIdentity(e,s,t),s}updateWebIdentity(e,t,i){this.IdentityService.update(e,{session:t._id,user:t.user,token:t.token,roles:t.roles,groups:[],scope:[],profile:{_id:i._id,displayName:i.displayName,displayImageURL:i.displayImageURL}})}};__decorate([singleton(),__metadata('design:type',WebIdentityService)],WebAuthenticationService.prototype,'IdentityService',void 0),__decorate([singleton(),__metadata('design:type',SessionService)],WebAuthenticationService.prototype,'SessionService',void 0),WebAuthenticationService=__decorate([service()],WebAuthenticationService);class EmailGetters{static async GetById(e,t){const i=e.collection(EmailCollection);return i.findOne({_id:CreateObjectId(t)})}static async GetByEmailAddress(e,t){const i=e.collection(EmailCollection);return i.findOne({name:t})}}let UserService=class e extends Resolvable$1{findById(e,t){if(null==t)throw new TypeError('id is required');return UserGetters.GetUserById(e,t)}async findByEmail(e,t){if(!t)throw new TypeError('email is required');const i=await EmailGetters.GetByEmailAddress(e,t);return i&&i.user?UserGetters.GetUserById(e,i.user):null}CreateFromExternalUser(e,t){return UserMutations.CreateFromExternalUser(e,t)}};UserService=__decorate([service()],UserService);let ExternalUserService=class e extends Resolvable$1{findOrCreateExternalUser(e,t){return ExternalUserMutations.FindOrCreateExternalUser(e,t)}};ExternalUserService=__decorate([service()],ExternalUserService);var Fetch_1;let Fetch=Fetch_1=class e extends WebFoundationUserService{fetch(){const{url:e,init:t}=Fetch_1.parseFetchArguments(arguments),i={};if(e)t?t&&(i.method=t.method,i.url=e,i.data=t.data):(i.method='get',i.url=e);else if(t)i.method=t.method,i.url=t.url,i.data=t.data;else throw new Error('Invalid fetch parameters');return i.headers=this.buildAuthorisedHeaders(e,t),axios(i).then(e=>(this.addResponseHeader('Server-Timing',e.headers['Server-Timing']),e.data?(e.data.headers=e.headers,e.data):{ok:!1,headers:e.headers,status:e.status,message:e.statusText}))}static parseFetchArguments(e){const t=e.length-1;let i,n;for(let o=0;o<=t;o++)if(!i&&'string'==typeof e[o])i=e[o];else if(!n&&'object'==typeof e[o])n=e[o];else break;return{url:i,init:n}}buildAuthorisedHeaders(e,t){return{Authorization:'Bearer '+this.domain.token,"User-Agent":this.getRequestHeader('User-Agent'),"X-Request-Id":this.domain.context().req_id}}};Fetch=Fetch_1=__decorate([service$1()],Fetch);class WebFoundationContextDomain{constructor(e){this.ctx=e}get identity(){return this.ctx.identity}get resolver(){return this.ctx}get db(){return this.ctx.state.db}get settings(){return this.ctx.settings}get logger(){return this.ctx.logger}get token(){return this.ctx.identity.id}construct(e,t){return this.ctx.construct(e,t)}resolve(e,t){return this.ctx.resolve(e,t)}collection(e){return this.db.collection(e)}trace(e,t,...i){this.logger.trace.apply(this.logger,arguments)}debug(e,t,...i){this.logger.debug.apply(this.logger,arguments)}log(e,t,...i){this.logger.log.apply(this.logger,arguments)}info(e,t,...i){this.logger.info.apply(this.logger,arguments)}warn(e,t,...i){this.logger.warn.apply(this.logger,arguments)}error(e,t,...i){this.logger.error.apply(this.logger,arguments)}fatal(e,t,...i){this.logger.fatal.apply(this.logger,arguments)}child(e){return this.logger.child(e)}update(e){return this.logger.update(e)}context(){return this.logger.context()}fetch(){return this.resolve(Fetch).then(e=>e.fetch.apply(e,arguments))}has(e){return Reflect.has(this.ctx.settings,e)}set(e,t){return this.ctx.set(e,t)}}var _a;class WebFoundationController extends WebController{async[_a=Symbol('Upgrade')](e,t){if(e.domain=new WebFoundationContextDomain(e),e.identity&&e.identity.profile){const t=e.identity.profile;t&&t._id&&t._id.toString&&e.req.logger.update({uid:t._id.toString()})}return e.settings.MONGODB_URL&&(e.logger.info('Resolve Graph'),e.state.db=await e.resolve(Graph)),t().then(t=>(e.releaseSingleton(Graph),delete e.domain,t))}async getFailureURL(e,t){if(e.settings.WEBAPP_LOGIN_FAILED_PATH){const i=e.res.get('X-Request-Id')||'',n={req_id:i,message:t.message};return e.logger.warn(t,'Redirect to error page'),e.settings.WEBAPP_LOGIN_FAILED_PATH+'?'+stringify(n)}throw new Exception(t,'"WEBAPP_LOGIN_FAILED_PATH" is not set')}}__decorate([middleware(),__metadata('design:type',Function),__metadata('design:paramtypes',[Object,Function]),__metadata('design:returntype',Promise)],WebFoundationController.prototype,_a,null);class OAuthController extends WebFoundationController{async __OAuthController_Start(e){let t;try{const i=await this.authenticator(e),n=resolve(e.publicUrl,'callback');t=i.getAuthorizeURL(n,Date.now())}catch(i){t=await this.getFailureURL(e,new Exception(i,'Unable to start authentication'))}e.redirect(t)}async __OAuthController_Callback(e){const t=await this.authenticator(e),i=resolve(e.publicUrl,'callback'),n=+e.query.state,o=new WebFoundationContextDomain(e);if(n>Date.now()||n<Date.now()-3e5)return void e.redirect(t.getFailureURL(new Error('Invalid Authentication State')));if(e.query.error){const i=new Error(`${e.query.error}: ${e.query.error_description}`);e.logger.error(i,'Authentication Error'),e.redirect(t.getFailureURL(i))}try{const n=e.query.code,d=await t.getToken(i,n),s=await t.getProfile(d),r=await this.ExternalUserService.findOrCreateExternalUser(o,s);let p=r.user?await this.UserService.findById(o,r.user):null;const a=e.state.user,y=await this.callback(e,r,p,a);e.redirect(t.getSuccessURL(y))}catch(i){e.logger.error(i,'Authentication Callback Error'),e.redirect(t.getFailureURL(i))}}}__decorate([singleton$1(),__metadata('design:type',ExternalUserService)],OAuthController.prototype,'ExternalUserService',void 0),__decorate([singleton$1(),__metadata('design:type',UserService)],OAuthController.prototype,'UserService',void 0),__decorate([method('GET','/start'),__metadata('design:type',Function),__metadata('design:paramtypes',[Object]),__metadata('design:returntype',Promise)],OAuthController.prototype,'__OAuthController_Start',null),__decorate([method('GET','/callback'),__metadata('design:type',Function),__metadata('design:paramtypes',[Object]),__metadata('design:returntype',Promise)],OAuthController.prototype,'__OAuthController_Callback',null);class MicrosoftOAuthController extends OAuthController{async authenticator(e){if(!e.settings.OAUTH_MICROSOFT)throw new AuthenticationError('OAuth for Microsoft AD is not been enabled',501);else{const t=await this.configure(e),i=await e.resolve(MicrosoftAuthenticator,!0);return i.init(t),i}}}export{SYSTEM_MAX_UPLOAD_SIZE,SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER,WebFoundationApplication,WebFoundationApplicationSettings,Graph,EmailCollection,EmailModel,ExternalUserCollection,ExternalUserModel,SessionCollection,SessionModel,UserCollection,UserModel,CurrentUser,ExternalUserMutations,SessionMutations,UserMutations,ExternalUserGetters,SessionGetters,UserGetters,RestClient,MicrosoftClient,MicrosoftAuthenticator,WebIdentityService,WebAuthenticationService,SessionService,UserService,ExternalUserService,MicrosoftOAuthController,WebFoundationController};
//# sourceMappingURL=index.esm.js.map
