/* Enterprise Web Application Stack */'use strict';Object.defineProperty(exports,'__esModule',{value:!0});function _interopDefault(e){return e&&'object'==typeof e&&'default'in e?e['default']:e}var web=require('@e2/web'),mongodb=require('@e2/mongodb'),core=require('@e2/core'),protobufjs=require('protobufjs'),agentframework=require('agentframework'),lodash=require('lodash'),axios=_interopDefault(require('axios')),crypto=require('crypto'),oauth2=require('simple-oauth2'),querystring=require('querystring'),url=require('url');const SYSTEM_MAX_UPLOAD_SIZE=15728640,SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER=1;/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */function __decorate(e,t,o,n){var s,p=arguments.length,a=3>p?t:null===n?n=Object.getOwnPropertyDescriptor(t,o):n;if('object'==typeof Reflect&&'function'==typeof Reflect.decorate)a=Reflect.decorate(e,t,o,n);else for(var l=e.length-1;0<=l;l--)(s=e[l])&&(a=(3>p?s(a):3<p?s(t,o,a):s(t,o))||a);return 3<p&&a&&Object.defineProperty(t,o,a),a}function __metadata(e,t){if('object'==typeof Reflect&&'function'==typeof Reflect.metadata)return Reflect.metadata(e,t)}let EdgeModel=class e extends mongodb.MongoModel{collection(){return this[mongodb.MongoSymbols.CollectionInstance]}};__decorate([mongodb.property(),__metadata('design:type',String)],EdgeModel.prototype,'outType',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],EdgeModel.prototype,'label',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],EdgeModel.prototype,'inType',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],EdgeModel.prototype,'outV',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],EdgeModel.prototype,'inV',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],EdgeModel.prototype,'meta',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],EdgeModel.prototype,'expires',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],EdgeModel.prototype,'createdAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],EdgeModel.prototype,'createdFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],EdgeModel.prototype,'createdBy',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],EdgeModel.prototype,'updatedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],EdgeModel.prototype,'updatedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],EdgeModel.prototype,'updatedBy',void 0),EdgeModel=__decorate([mongodb.model('edge')],EdgeModel);class Collection extends mongodb.MongoCollection{}class EdgeCollection extends Collection{constructor(e){super(e,EdgeModel)}outV(e,t,o={},n={},r={}){return this.aggregation({filter:Object.assign(o,{outV:e,label:t}),lookup:{inV:t},projection:n,sort:r})}inV(e,t,o,n={},r={},i={}){return this.aggregation({filter:Object.assign(n,{inV:e,label:t}),lookup:{outV:o},projection:r,sort:i})}removeRelationships(e){return Promise.all([this.find({outV:e}).then(e=>e.results),this.find({inV:e}).then(e=>e.results)]).then(([e,t])=>e.length||t.length?this.deleteMany([...e,...t]):[])}static getIndices(){return[{name:'unique_relationship',key:{inV:1,inType:1,label:1,outV:1,outType:1},unique:!0},{name:'index_outV_outType_inV_inType',key:{outV:1,outType:1,inV:1,inType:1}},{name:'index_outV_outType_label_inType',key:{outV:1,outType:1,label:1,inType:1}},{name:'index_outV_outType_label',key:{outV:1,outType:1,label:1}},{name:'index_outV_outType_inType',key:{outV:1,outType:1,inType:1}},{name:'index_outV_outType',key:{outV:1,outType:1}},{name:'index_inV_inType_label_inType',key:{inV:1,inType:1,label:1,outType:1}},{name:'index_inV_inType_label',key:{inV:1,inType:1,label:1}},{name:'index_inV_inType_inType',key:{inV:1,inType:1,outType:1}},{name:'index_inV_inType',key:{inV:1,inType:1}},{name:'index_deleted',key:{deleted:1}},{name:'index_blocked',key:{blocked:1}}]}createIndices(){return super.createIndex(EdgeCollection.getIndices())}}let EdgeSymbolKey=Symbol.for('agentframework.mongodb.graph.edge');class VertexModel extends mongodb.MongoModel{collection(){return this[mongodb.MongoSymbols.CollectionInstance]}$edge(){const e=this[EdgeSymbolKey];return!!e&&e.label}addEdgeFrom(e,t,o={}){const n=this.collection().graph().collection(EdgeCollection),r={outType:t.getType(),label:e,inType:this.getType(),outV:t._id,inV:this._id,meta:o};return core.retry(()=>n.insertOne(r))}addEdgeTo(e,t,o={}){const n=this.collection().graph().collection(EdgeCollection),r={outType:this.getType(),label:e,inType:t.getType(),outV:this._id,inV:t._id,meta:o};return core.retry(()=>n.insertOne(r))}fetch(){return this.collection().findOneById(this._id).then(e=>{if(!e)throw new Error('unable to fetch current model object');return Object.assign(this,e),e})}findEdges(){const e=this.collection().graph().collection(EdgeCollection),t=this._id,o=this.getType();return e.find({$or:[{inV:t,inType:o},{outV:t,outType:o}]}).then(e=>e.results)}findOutEdges(){const e=this.collection().graph().collection(EdgeCollection),t=this._id,o=this.getType();return e.find({inV:t,inType:o}).then(e=>e.results)}findInEdges(){const e=this.collection().graph().collection(EdgeCollection),t=this._id,o=this.getType();return e.find({outV:t,outType:o}).then(e=>e.results)}findFromVertices(e,t){return this.findOutVertices(e,t)}findToVertices(e,t){return this.findInVertices(e,t)}findOutVertices(e,t){const o=this.collection().graph().collection(EdgeCollection),n=this._id,r=this.getType(),i=e.getType();return o.aggregation({filter:t?{inV:n,inType:r,label:t,outType:i}:{inV:n,inType:r,outType:i},lookup:{outV:i}}).then(t=>{const o=[];return t.forEach(t=>{const n=e.wrap(t.outV);n&&(Reflect.set(n,EdgeSymbolKey,t),o.push(n))}),o})}findInVertices(e,t){const o=this.collection().graph().collection(EdgeCollection),n=this._id,r=this.getType(),i=e.getType();return o.aggregation({filter:t?{outV:n,outType:r,label:t,inType:i}:{outV:n,outType:r,inType:i},lookup:{inV:i,outV:r}}).then(t=>{const o=[];return t.forEach(t=>{const n=e.wrap(t.inV);n&&(Reflect.set(n,EdgeSymbolKey,t),o.push(n))}),o})}findOutTypes(e){const t=this.collection().graph().collection(EdgeCollection),o=this._id,n=this.getType();return t.find({inV:o,inType:n,label:e}).then(e=>Array.from(new Set(e.results.map(e=>e.inType))))}findInTypes(e){const t=this.collection().graph().collection(EdgeCollection),o=this._id,n=this.getType();return t.find({outV:o,outType:n,label:e}).then(e=>Array.from(new Set(e.results.map(e=>e.inType))))}findOutLabels(e){const t=this.collection().graph().collection(EdgeCollection),o=this._id,n=this.getType(),r=e.getType();return t.find({inV:o,inType:n,outType:r}).then(e=>Array.from(new Set(e.results.map(e=>e.label))))}findInLabels(e){const t=this.collection().graph().collection(EdgeCollection),o=this._id,n=this.getType(),r=e.getType();return t.find({inV:o,inType:n,outType:r}).then(e=>Array.from(new Set(e.results.map(e=>e.label))))}}__decorate([mongodb.property(),__metadata('design:type',Date)],VertexModel.prototype,'expires',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],VertexModel.prototype,'createdAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],VertexModel.prototype,'createdFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],VertexModel.prototype,'createdBy',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],VertexModel.prototype,'updatedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],VertexModel.prototype,'updatedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],VertexModel.prototype,'updatedBy',void 0),exports.UserModel=class e extends VertexModel{},exports.UserModel=__decorate([mongodb.model('user')],exports.UserModel);class UserCollection extends Collection{constructor(e){super(e,exports.UserModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(UserCollection.getIndices())}}class CurrentUser extends exports.UserModel{static[web.TypeRegistry.Initializer](e,t){const o=t.identity.user;return'string'==typeof o?t.state.db.collection(UserCollection).findOneById(o).then(e=>(e&&Reflect.setPrototypeOf(e,CurrentUser.prototype),e)):null}}class WebIdentity{}class Graph extends mongodb.MongoDatabase{constructor(e,t,o){super(e,t),this.identity=o?o.identity:t.identity}audit(e,t={},o){return'boolean'==typeof o&&(t[''+e]=o),t[''+e+'At']=new Date,t[''+e+'From']=this.identity.address,t[''+e+'By']=this.identity.profile,t}}class SecuredCookie extends core.Resolvable{constructor(e){super(e),this.crypts=new web.Keygrip(e.settings.WEBAPP_SESSION_COOKIE_SECRET,'sha1'),this.base72=new core.BaseX('0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ:/?&=.-,@%')}sign(e){const t=this.crypts.sign(e);return core.Base62.fromBuffer(this.base72.toBuffer(e))+'.'+core.Base62.fromBuffer(t)}verify(e){try{const t=e.split('.'),o=this.base72.fromBuffer(core.Base62.toBuffer(t[0])),n=core.Base62.toBuffer(t[1]);return!!this.crypts.verify(o,n)&&o}catch(e){return console.log('verify key error',e),!1}}}let SessionCookieManager=class e extends core.Resolvable{get(e){const t=e.cookies.get(e.settings.WEBAPP_SESSION_COOKIE_KEY);if(t){const o=this.security.verify(t);if(o)return o;e.logger.warn({fingerprint:e.fingerprint(),cookie:t},'[INTRUSION DETECTED] User sent invalidate auth token:')}return null}set(e,t){const o={path:e.settings.WEBAPP_SESSION_COOKIE_PATH,httpOnly:!0,maxAge:e.settings.WEBAPP_SESSION_COOKIE_EXPIRES_IN_SECONDS,secure:e.settings.WEBAPP_SESSION_COOKIE_SECURED,overwrite:!0};e.settings.WEBAPP_SESSION_COOKIE_EXPIRES_IN_SECONDS||delete o.maxAge,e.cookies.set(e.settings.WEBAPP_SESSION_COOKIE_KEY,this.security.sign(t),o)}clear(e){const t={path:e.settings.WEBAPP_SESSION_COOKIE_PATH,httpOnly:!0,maxAge:1,expires:new Date(2013,1,1),secure:e.settings.WEBAPP_SESSION_COOKIE_SECURED,overwrite:!0};e.cookies.set(e.settings.WEBAPP_SESSION_COOKIE_KEY,'',t)}};__decorate([core.singleton(),__metadata('design:type',SecuredCookie)],SessionCookieManager.prototype,'security',void 0),SessionCookieManager=__decorate([core.service()],SessionCookieManager);class SessionProtocol{static[core.TypeRegistry.Singleton](){return protobufjs.Root.fromJSON({nested:{IdentityProfile:{fields:{_id:{type:'bytes',id:1},displayName:{type:'string',id:2},displayImageURL:{type:'string',id:3}}},WebSession:{fields:{session:{type:'bytes',id:1},user:{type:'bytes',id:2},token:{type:'bytes',id:3},roles:{type:'string',rule:'repeated',id:4},groups:{type:'string',rule:'repeated',id:5},scope:{type:'string',rule:'repeated',id:6},profile:{type:'IdentityProfile',id:7}}}}}).lookupType('WebSession')}static get schema(){const e=this[core.TypeRegistry.Singleton];if(e){const e=this[core.TypeRegistry.Singleton]();return Reflect.defineProperty(this,'schema',{value:e}),e}throw new Error('TypeRegistry.Singleton is not found')}}class SessionScheme extends SessionProtocol{static encode(e){const t=Object.assign({},e);if(e.session instanceof mongodb.ObjectId&&(t.session=e.session.id),e.user instanceof mongodb.ObjectId&&(t.user=e.user.id),e.token instanceof mongodb.ObjectId&&(t.token=e.token.id),e.token instanceof mongodb.ObjectId&&(t.token=e.token.id),e.profile){let o;o=e.profile._id instanceof mongodb.ObjectId?e.profile._id.id:'string'==typeof e.profile._id?Buffer.from(e.profile._id,'hex'):new Buffer(0),t.profile={_id:o,displayName:e.profile.displayName,displayImageURL:e.profile.displayImageURL}}return new Buffer(this.schema.encode(t).finish())}static decode(e){const t=this.schema.decode(e);Buffer.isBuffer(t.session)&&(t.session=new mongodb.ObjectId(t.session)),Buffer.isBuffer(t.user)&&(t.user=new mongodb.ObjectId(t.user)),Buffer.isBuffer(t.token)&&(t.token=new mongodb.ObjectId(t.token));const o=t.profile;if(o){let e;e=Buffer.isBuffer(o._id)?new mongodb.ObjectId(o._id):null,t.profile={_id:e,displayName:o.displayName,displayImageURL:o.displayImageURL}}return t}}exports.WebIdentityService=class e extends core.Resolvable{get name(){return'WebIdentityService'}create(e,t){const o=this.sessionCookie.get(e);return o&&o.length?SessionScheme.decode(core.Base62.toBuffer(o)):{}}update(e,t){const o=Object.keys(t);if(!o.length)throw new web.ParameterError('Unable to update empty identity, please use WebIdentityService.clear() instead');const n=SessionScheme.encode(t);if(!n||!n.byteLength)throw new web.AuthenticationError('Invalid session data (byteLength=0)');console.log('got data',core.Base62.fromBuffer(n).length),this.sessionCookie.set(e,core.Base62.fromBuffer(n))}clear(e){for(const t of Object.keys(e.identity))'id'!==t&&'address'!==t&&delete e.identity[t];this.sessionCookie.clear(e)}},__decorate([core.singleton(),__metadata('design:type',SessionCookieManager)],exports.WebIdentityService.prototype,'sessionCookie',void 0),exports.WebIdentityService=__decorate([core.service()],exports.WebIdentityService);class WebFoundationApplication extends web.WebApplication{createRequestState(e,t){return Object.create(Object.create(this.state))}createRequestIdentity(e,t,o){const n=new WebIdentity;return n.id=t,n.address=o,Object.assign(n,this.WebIdentityService.create(e)),n}onInitApplication(){if(this.settings.MONGODB_URL&&(this.addGlobalType(mongodb.MongoClient),this.addType(mongodb.MongoClient),this.addType(Graph),this.addType(CurrentUser),Array.isArray(this.settings.OIDC_PROVIDERS)&&this.settings.OIDC_PROVIDERS.length));this.resolve(exports.WebIdentityService).then(e=>{this.WebIdentityService=e},e=>{this.exit(e)})}}class WebFoundationApplicationSettings extends web.WebApplicationSettings{constructor(){super(...arguments),this.ADMIN_EMAIL='',this.MONGODB_URL='',this.MONGODB_DATABASE='',this.MONGODB_EVENT_LOG_LEVEL='',this.WEBAPP_SESSION_COOKIE_PATH='/api',this.WEBAPP_SESSION_COOKIE_KEY='y',this.WEBAPP_SESSION_COOKIE_SECRET=['1234567890abcdefgh'],this.WEBAPP_SESSION_COOKIE_SECURED=!1,this.WEBAPP_SESSION_COOKIE_EXPIRES_IN_SECONDS=0,this.WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEBAPP_TOKEN_EXPIRES_IN_MILLISECONDS=3e4,this.WEBAPP_INVITATION_EXPIRES_IN_MILLISECONDS=12096e5,this.WEBAPP_EMAIL_VERIFICATION_RESEND_COOLDOWN_IN_MILLISECONDS=6e4,this.WEBAPP_EMAIL_VERIFICATION_EXPIRES_IN_MILLISECONDS=216e5,this.WEBAPP_LOGIN_PATH='/api/user/signin',this.WEBAPP_LOGIN_SUCCESS_PATH='',this.WEBAPP_LOGIN_FAILED_PATH='',this.WEBAPP_LOGOUT_PATH='/api/user/signout',this.WEBAPP_LOGOUT_COMPLETE_PATH='',this.MAX_NUMBER_OF_ACCOUNTS_PER_USER=SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER,this.MAX_UPLOAD_SIZE=SYSTEM_MAX_UPLOAD_SIZE}}__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'ADMIN_EMAIL',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'MONGODB_URL',void 0),__decorate([web.conf(),__metadata('design:type',Object)],WebFoundationApplicationSettings.prototype,'MONGODB_DATABASE',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'MONGODB_EVENT_LOG_LEVEL',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_PATH',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_KEY',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_SECRET',void 0),__decorate([web.conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_SECURED',void 0),__decorate([web.conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_COOKIE_EXPIRES_IN_SECONDS',void 0),__decorate([web.conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS',void 0),__decorate([web.conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_TOKEN_EXPIRES_IN_MILLISECONDS',void 0),__decorate([web.conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_INVITATION_EXPIRES_IN_MILLISECONDS',void 0),__decorate([web.conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_EMAIL_VERIFICATION_RESEND_COOLDOWN_IN_MILLISECONDS',void 0),__decorate([web.conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'WEBAPP_EMAIL_VERIFICATION_EXPIRES_IN_MILLISECONDS',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGIN_PATH',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGIN_SUCCESS_PATH',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGIN_FAILED_PATH',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGOUT_PATH',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'WEBAPP_LOGOUT_COMPLETE_PATH',void 0),__decorate([web.conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'MAX_NUMBER_OF_ACCOUNTS_PER_USER',void 0),__decorate([web.conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'MAX_UPLOAD_SIZE',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'JDK_ACCESS_KEY',void 0),__decorate([web.conf(),__metadata('design:type',Number)],WebFoundationApplicationSettings.prototype,'OAUTH_AUTHENTICATION_EXPIRES_IN_MILLISECONDS',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_REDIRECT_LIST',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_NO_REDIRECTS_LIST',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OIDC_PROVIDERS',void 0),__decorate([web.conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_GOOGLE',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GOOGLE_CLIENT_ID',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GOOGLE_CLIENT_SECRET',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_GOOGLE_SCOPE',void 0),__decorate([web.conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_TENANT_ID',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_CLIENT_ID',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_CLIENT_SECRET',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_BASE_URL',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_MICROSOFT_SCOPE',void 0),__decorate([web.conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB_CLIENT_ID',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB_CLIENT_SECRET',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB_BASE_URL',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_GITLAB_SCOPE',void 0),__decorate([web.conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_GITHUB',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITHUB_CLIENT_ID',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_GITHUB_CLIENT_SECRET',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_GITHUB_SCOPE',void 0),__decorate([web.conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_WEIBO',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_WEIBO_CLIENT_ID',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_WEIBO_CLIENT_SECRET',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_WEIBO_SCOPE',void 0),__decorate([web.conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_WECHAT',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_WECHAT_CLIENT_ID',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_WECHAT_CLIENT_SECRET',void 0),__decorate([web.conf(),__metadata('design:type',Array)],WebFoundationApplicationSettings.prototype,'OAUTH_WECHAT_SCOPE',void 0),__decorate([web.conf(),__metadata('design:type',Boolean)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM_BOT_ID',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM_BOT_SECRET',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM_BOT_TOKEN',void 0),__decorate([web.conf(),__metadata('design:type',String)],WebFoundationApplicationSettings.prototype,'OAUTH_TELEGRAM_PAYMENT_TOKEN',void 0),exports.EmailModel=class e extends VertexModel{},exports.EmailModel=__decorate([mongodb.model('email')],exports.EmailModel);class EmailCollection extends Collection{constructor(e){super(e,exports.EmailModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(EmailCollection.getIndices())}}exports.ExternalUserModel=class e extends VertexModel{},__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'uid',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'provider',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'providerProtocol',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'providerData',void 0),__decorate([mongodb.property(),__metadata('design:type',Array)],exports.ExternalUserModel.prototype,'identities',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'user',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'username',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'domain',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'email',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.ExternalUserModel.prototype,'emailCertified',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'mobile',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.ExternalUserModel.prototype,'mobileCertified',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'displayName',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'displayImageURL',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.ExternalUserModel.prototype,'displayImageFile',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'familyName',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'givenName',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'gender',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'dob',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'status',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'bio',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'homepage',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.ExternalUserModel.prototype,'blocked',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ExternalUserModel.prototype,'blockedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'blockedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'blockedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'blockedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.ExternalUserModel.prototype,'deleted',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ExternalUserModel.prototype,'deletedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'deletedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'deletedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'deletedReason',void 0),exports.ExternalUserModel=__decorate([mongodb.model('external_user')],exports.ExternalUserModel);class ExternalUserCollection extends Collection{constructor(e){super(e,exports.ExternalUserModel)}static getIndices(){return[{name:'unique_external_user',key:{provider:1,providerProtocol:1,uid:1},unique:!0},{name:'index_provider',key:{provider:1}},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(ExternalUserCollection.getIndices())}}exports.SessionModel=class e extends VertexModel{},exports.SessionModel=__decorate([mongodb.model('session')],exports.SessionModel);class SessionCollection extends Collection{constructor(e){super(e,exports.SessionModel)}}class ExternalUserMutations{static async FindExternalUser(e,t){const o=e.collection(ExternalUserCollection),n={provider:t.provider+'',providerProtocol:t.providerProtocol+'',uid:agentframework.IsNumber(t.uid)?+t.uid:t.uid+''};return o.findOne(n)}static async FindOrCreateExternalUser(e,t){const o=e.collection(ExternalUserCollection),n={provider:t.provider+'',providerProtocol:t.providerProtocol+'',uid:agentframework.IsNumber(t.uid)?+t.uid:t.uid+''};return o.findOneAndUpsert(n,{$set:t}).then(e=>{if(!e)throw new Error('Unable to create external user');return e})}}const lodash$1=require('lodash');class SessionMutations{static async CreateSession(e,t,o,n,r,i){const s=mongodb.CreateObjectId(),p={user:t._id,device:e.identity.id,roles:lodash$1.intersection(t.roles,o),expires:new Date(Date.now()+e.settings.WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS),token:s,tokens:[{token:s,context:n}]};r&&(p.previous=r._id.toString(),i&&(p.impersonated=!0,p.impersonatedAt=new Date));const d=e.collection(SessionCollection);return web.retry(()=>d.insertOne(p)).then(e=>{if(!e)throw new web.AuthenticationError('unable to create session');return e})}static async CreateOrUpdateSession(e,t,o,n,r){const i=mongodb.CreateIdString(),s=await e.resolve(Graph),p=s.collection(SessionCollection);return p.findOneAndUpdate({_id:mongodb.CreateObjectId(e.identity.id)},{$set:{user:mongodb.IdStr(t),device:e.identity.id,account:n,roles:lodash$1.intersection(t.roles,o),token:i,expires:new Date(Date.now()+31536000000)},$push:{tokens:{token:i,context:r}}}).then(s=>s?s:p.insertOne({_id:mongodb.CreateObjectId(e.identity.id),user:mongodb.IdStr(t),device:e.identity.id,account:n,roles:lodash$1.intersection(t.roles,o),expires:new Date(Date.now()+31536000000),token:i,tokens:[{token:i,context:r}]}))}static async ExtendSession(e,t){const o=mongodb.CreateIdString(),n=e.identity,r=e.collection(SessionCollection);return null===typeof n.session?Promise.reject(new web.AuthenticationError('Unable to extend null session')):r.findOneAndUpdate({_id:n.session,device:n.id,user:n.user,token:n.token,expires:{$gt:new Date},deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{token:o,expires:new Date(Date.now()+e.settings.WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS)},$push:{tokens:{token:o,context:t}}},{tokens:0}).then(e=>e?e:r.findOne({_id:n.session,device:n.id,user:n.user,tokens:{$elemMatch:{token:n.token}},expires:{$gt:new Date},deleted:{$ne:!0},blocked:{$ne:!0}},{tokens:0}).then(e=>{if(!e)throw new web.AuthenticationError('extended session not found');return e}))}static async RestoreSession(e,t,o,n){const r=mongodb.CreateIdString(),i=e.identity,s=e.settings.WEBAPP_SESSION_EXPIRES_IN_MILLISECONDS,p=await e.resolve(Graph),d=p.collection(SessionCollection);return d.findOneAndUpdate({_id:t._id.toString(),device:i.id,deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{token:r,expires:new Date(Date.now()+s)},$push:{tokens:{token:r,context:o,restoreReason:n}}},{tokens:0})}static async TerminateSession(e,t){const o=e.identity;if(!o.session)return Promise.resolve(null);const n=await e.resolve(Graph),r=n.collection(SessionCollection);return r.findOneAndAudit({_id:mongodb.CreateObjectId(o.session),user:o.user,device:o.id},mongodb.MongoAuditEvents.Deleted,!0,{$set:{deletedReason:t}},{tokens:0}).then(e=>e,e=>{throw new web.Exception(e,`Error during terminate user session, need manual update session '${o.session}.exited' to 'true'`)})}}function Audit(e,t,o={},n){return'boolean'==typeof n&&(o[''+t]=n),o[''+t+'At']=new Date,o[''+t+'From']=e.address||null,o[''+t+'By']=e.profile||null,o}class EmailMutations{static async CreateEmailFromExternalUser(e,t){if(!t.user)throw new web.AuthenticationError(`Unable to create email for external user ${t._id} without user account linked`);if(!t.email)throw new web.AuthenticationError(`Unable to create email for external user ${t._id} without a valid email address`);if(!t.emailCertified)throw new web.AuthenticationError(`Unable to create email for external user ${t._id} without a certified email address`);const o=Audit(e.identity,'verified',{name:t.email,displayName:t.displayName,user:t.user}),n=e.collection(EmailCollection);return n.insertOne(o)}}class UserMutations{static async FindOrCreateFromExternalUser(e,t){const o=e.collection(UserCollection);return t.user?o.findOneById(t.user).then(e=>{if(!e)throw new web.AuthenticationError(`External user ${t._id.toString()} connected to an non-exists user`);return e}):UserMutations.CreateFromExternalUser(e,t)}static async CreateFromExternalUser(e,t){const o=e.settings,n={displayName:t.displayName,displayImageURL:t.displayImageURL,roles:['user'],settings:{MAX_NUMBER_OF_ACCOUNTS_PER_USER:o.MAX_NUMBER_OF_ACCOUNTS_PER_USER,MAX_UPLOAD_SIZE:o.MAX_UPLOAD_SIZE}};t.emailCertified&&o.ADMIN_EMAIL&&o.ADMIN_EMAIL===t.email&&n.roles.push('admin');const r=await e.resolve(Graph),i=r.collection(UserCollection),s=r.collection(ExternalUserCollection);return i.insertOne(n).then(o=>{if(!o)throw new web.ApplicationError('Unable to create user');return s.findOneAndUpdate({_id:t._id},{$set:{user:o._id}}).then(n=>{if(!n)throw new web.ApplicationError(`Unable to update external user ${t._id} with new created user. Need delete user ${o._id}`);return n.email&&n.emailCertified?EmailMutations.CreateEmailFromExternalUser(e,n).then(()=>o,()=>o):o})})}static async FindOrCreateFromEmail(e,t){const o=e.collection(UserCollection);return o.findOneById(t.user).then(o=>o?o:UserMutations.CreateFromEmail(e,t))}static async CreateFromEmail(e,t){if(!t.verified)throw new web.AuthenticationError(`Not allow to create user with unverified email: ${t.name}`);if(t.user)throw new web.AuthenticationError(`Not allow to create another user for same email: ${t.name}`);const o=e.settings,n={displayName:t.displayName,roles:['user'],settings:{MAX_NUMBER_OF_ACCOUNTS_PER_USER:o.MAX_NUMBER_OF_ACCOUNTS_PER_USER,MAX_UPLOAD_SIZE:o.MAX_UPLOAD_SIZE},identities:{email:t.name}};o.ADMIN_EMAIL&&o.ADMIN_EMAIL.length&&!!~o.ADMIN_EMAIL.indexOf(t.name)&&n.roles.push('admin');const r=await e.resolve(Graph),i=r.collection(UserCollection),s=r.collection(EmailCollection);return i.insertOne(n).then(e=>{if(!e)throw new web.ApplicationError('Unable to create user from email '+t.name);return s.findOneAndUpdate({_id:t._id},{$set:{user:e._id}}).then(t=>{if(!t)throw new web.AuthenticationError('Unable to update email with new created user, need manual delete user '+e._id.toString());return e})})}static async Update(e,t,o){const n=e.collection(UserCollection);return n.findOneAndUpdate({_id:t._id},{$set:o})}}class ExternalUserGetters{static FindExternalUser(e,t){const o={provider:`${t.provider}`,providerProtocol:`${t.providerProtocol}`,uid:web.IsNumber(t.uid)?t.uid:t.uid+''},n=e.collection(ExternalUserCollection);return n.findOne(o)}}class SessionGetters{static async GetUserById(e,t){const o=e.collection(UserCollection);return o.findOne({_id:mongodb.CreateObjectId(t)})}static async GetExternalUserFromUser(e,t,o,n){const r=e.collection(ExternalUserCollection);return t.findOutVertices(r,'created').then(e=>{const t=lodash.filter(e,{provider:o,providerProtocol:n});if(t&&t.length){const e=t[0];return e}return null})}}class UserGetters{static async GetUserById(e,t){const o=e.collection(UserCollection);return o.findOne({_id:mongodb.CreateObjectId(t)})}static async GetExternalUserFromUser(e,t,o,n){const r=e.collection(ExternalUserCollection);return t.findOutVertices(r,'created').then(e=>{const t=lodash.filter(e,{provider:o,providerProtocol:n});if(t&&t.length){const e=t[0];return e}return null})}}class RestClient{constructor(e={}){this.defaults=e}makeAxiosOptions(e){const t=Object.assign({},this.defaults,e||{}),o={};return t.headers&&(o.headers=t.headers),t.query&&(o.params=t.query),t.responseType&&(o.responseType=t.responseType),o}post(e,t,o){return axios.post(e,t,this.makeAxiosOptions(o)).then(e=>e.data)}postBuffer(e,t,o){return this.post(e,t,Object.assign({responseType:'arraybuffer'},o||{}))}put(e,t,o){return axios.put(e,t,this.makeAxiosOptions(o)).then(e=>e.data)}putBuffer(e,t,o={}){return this.put(e,t,Object.assign({responseType:'arraybuffer'},o||{}))}get(e,t={}){return axios.get(e,this.makeAxiosOptions(t)).then(e=>e.data)}getBuffer(e,t={}){return this.get(e,Object.assign({responseType:'arraybuffer'},t||{}))}delete(e,t={}){return axios.delete(e,this.makeAxiosOptions(t)).then(e=>e.data)}deleteBuffer(e,t={}){return this.delete(e,Object.assign({responseType:'arraybuffer'},t||{}))}}class MicrosoftClient extends RestClient{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error('Access token can not be null or empty')}profile(){return this.get('https://graph.microsoft.com/v1.0/me')}photo(){return this.get('https://graph.microsoft.com/v1.0/me/photo').catch(e=>{const t=e.response.status;if(404===t||501===t)return null;throw console.log(e.response.status,e.response.statusText,e.response.data),new web.Exception(e,e.response.data,'Unable to resolve user photo')})}photoImage(e){return this.getBuffer(`https://graph.microsoft.com/v1.0/me/photos/${e}/$value`)}photoImageURL(){return this.photo().then(e=>{if(!e)return Promise.resolve(null);const t=e['@odata.mediaContentType'],o=e.id;return this.photoImage(o).then(e=>`data:${t};charset=utf-8;base64,${e.toString('base64')}`)})}users(){return this.get(`https://graph.microsoft.com/v1.0/users`)}}const FileNamePathMatcher=/^(\/.+)\/([^/]+)$/;class JdkClient extends RestClient{constructor(e){super({headers:{"x-api-key":`Bearer ${e}`}}),this.access_token=e}uploadFile(e,t,o){const n=e.match(FileNamePathMatcher);if(!n)throw new TypeError(`Invalid filename ${e}`);const r=n[1],i=n[2];return this.post(`https://res.jsonsdk.com/api/upload/file/${this.access_token}${r}`,{name:i,type:o,data:t.toString('base64')}).then(e=>{if(e.ok)return e.result.notValidBefore=new Date(e.result.notValidBefore),e.result.notValidAfter=new Date(e.result.notValidAfter),e.result.createdAt=new Date(e.result.createdAt),e.result;throw new Error('Unable to upload file: '+e.message)})}}let FileModel=class e extends VertexModel{};__decorate([mongodb.property(),__metadata('design:type',String)],FileModel.prototype,'path',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],FileModel.prototype,'name',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],FileModel.prototype,'originalname',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],FileModel.prototype,'type',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],FileModel.prototype,'size',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],FileModel.prototype,'hash',void 0),__decorate([mongodb.property(),__metadata('design:type',Array)],FileModel.prototype,'chunks',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],FileModel.prototype,'context',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],FileModel.prototype,'stats',void 0),__decorate([mongodb.property(),__metadata('design:type',Array)],FileModel.prototype,'tokens',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],FileModel.prototype,'expires',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],FileModel.prototype,'createdAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],FileModel.prototype,'createdFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],FileModel.prototype,'createdBy',void 0),FileModel=__decorate([mongodb.model('file')],FileModel);class FileCollection extends Collection{constructor(e){super(e,FileModel)}static getIndices(){return[{name:'unique_file',key:{path:1,name:1},unique:!0}]}createIndices(){return super.createIndex(FileCollection.getIndices())}}let FileChunkModel=class e extends VertexModel{};__decorate([mongodb.property(),__metadata('design:type',Object)],FileChunkModel.prototype,'hash',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],FileChunkModel.prototype,'type',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],FileChunkModel.prototype,'size',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],FileChunkModel.prototype,'offset',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],FileChunkModel.prototype,'length',void 0),__decorate([mongodb.property(),__metadata('design:type',Buffer)],FileChunkModel.prototype,'data',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],FileChunkModel.prototype,'dataSize',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],FileChunkModel.prototype,'dataEncoding',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],FileChunkModel.prototype,'expires',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],FileChunkModel.prototype,'createdAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],FileChunkModel.prototype,'createdFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],FileChunkModel.prototype,'createdBy',void 0),FileChunkModel=__decorate([mongodb.model('file_chunk')],FileChunkModel);class FileChunkCollection extends Collection{constructor(e){super(e,FileChunkModel)}static getIndices(){return[{name:'unique_chunk',key:{"hash.md5":1,"hash.sha1":1,"hash.sha256":1,"hash.ipfs":1},unique:!0,sparse:!0},{name:'index_hash_1',key:{"hash.md5":'hashed'}},{name:'index_hash_2',key:{"hash.sha1":'hashed'}},{name:'index_hash_3',key:{"hash.sha256":'hashed'}},{name:'index_hash_4',key:{"hash.ipfs":'hashed'}}]}createIndices(){return super.createIndex(FileChunkCollection.getIndices())}}let FileService=class e extends web.Resolvable{constructor(){super(...arguments),this.jdk=new JdkClient(this.settings.JDK_ACCESS_KEY)}enabled(){return!!this.settings.JDK_ACCESS_KEY}upload(e,t,o){return this.jdk.uploadFile(e,t,o)}async save(e,t,o,n,r,i=!1,s='untitled.file'){const p=t.byteLength;if(p>this.settings.MAX_UPLOAD_SIZE)throw new web.ParameterError('Buffer size over system limit');const d=e.collection(FileCollection),a=await d.findOne({path:n,name:r},{size:1,createdAt:1});if(a&&!i)throw new Error(`File ${n}/${r} already exists since ${a.createdAt.toISOString()} with size: ${a.size}`);const l=crypto.createHash('md5'),y=crypto.createHash('sha1'),c=crypto.createHash('sha256');l.update(t),y.update(t),c.update(t);const g=l.digest('hex'),_=y.digest('hex'),u=c.digest('hex'),E=e.collection(FileChunkCollection),{results:f}=await E.find({hash:{md5:g,sha1:_,sha256:u}},{offset:1,length:1,dataSize:1});if(!f.length){const e=await E.insertOne({hash:{md5:g,sha1:_,sha256:u},type:o,size:p,offset:0,length:p,data:t,dataSize:p,dataEncoding:'binary'});e&&f.push(e)}if(!f.length)throw new Error('unable to find or save file chunk');return d.findOneAndUpsert({path:n,name:r},{$setOnInsert:{path:n,name:r,stats:{view:0,download:0},tokens:[],context:null},$set:{originalname:s,type:o,size:p,hash:{md5:g,sha1:_,sha256:u},chunks:f.map(e=>({_id:e._id,offset:e.offset,length:e.length}))}}).then(e=>{if(!e)throw new Error('unable to save file');const t=e._id.toString();return{_id:e._id,id:t,url:'file://'+e.path+'/'+e.name,path:e.path,name:e.name||e.originalname,type:e.type,size:e.size,md5:e.hash.md5,sha1:e.hash.sha1,sha256:e.hash.sha256,createdAt:e.createdAt}})}async metadata(e,t){if(!mongodb.IsValidObjectId(t))throw new web.ParameterError('Invalid id parameter');const o=await e.collection(FileCollection);return o.findOneAndUpdate({_id:mongodb.CreateObjectId(t)},{$inc:{"stats.view":1}},{path:1,name:1,originalname:1,type:1,hash:1,size:1,dataSize:1,stats:1,expires:1,createdAt:1})}async content(e,t,o){if(!mongodb.IsValidObjectId(t))throw new web.ParameterError('Invalid id parameter');if(!mongodb.IsValidObjectId(o))throw new web.ParameterError('Invalid token parameter');const n=await e.collection(FileCollection);return n.findOneAndUpdate({_id:mongodb.CreateObjectId(t),"tokens.token":mongodb.CreateObjectId(o)},{$inc:{"stats.download":1}},{path:1,name:1,originalname:1,type:1,hash:1,size:1,dataSize:1,data:1,dataEncoding:1,stats:1,expires:1,createdAt:1})}};FileService=__decorate([core.service()],FileService);class InternalSymbol{}InternalSymbol.ServiceContext=Symbol('WfCtx');class WebFoundationUserService extends web.Resolvable{constructor(e,t){if(!t)throw new Error('User scoped service only can be created using ctx.resolve()');super(e),this[InternalSymbol.ServiceContext]=t}get domain(){const e=this[InternalSymbol.ServiceContext];return Reflect.defineProperty(this,'domain',{value:e.domain}),e.domain}addResponseHeader(e,t){this[InternalSymbol.ServiceContext].res.headers.append(e,t)}getRequestHeader(e){return this[InternalSymbol.ServiceContext].req.headers[e]}}exports.MicrosoftAuthenticator=class e extends WebFoundationUserService{constructor(){super(...arguments),this.certifiedEmails=['outlook.com','hotmail.com','live.com','msn.com','passport.com','passport.net']}init(e){const t=e.tenantId||'common';this.oauth=oauth2.create({client:{id:e.clientId,secret:e.clientSecret},auth:{tokenHost:'https://login.microsoftonline.com',tokenPath:`${t}/oauth2/v2.0/token`,authorizePath:`${t}/oauth2/v2.0/authorize`}}),this.scope=Array.isArray(e.scope)?e.scope.join(' '):'openid email profile offline_access'}getAuthorizeURL(e,t){return this.oauth.authorizationCode.authorizeURL({redirect_uri:e,scope:this.scope,state:t+''})}getSuccessURL(e){return'/'}getFailureURL(e){return'/'}getToken(e,t){return this.oauth.authorizationCode.getToken({redirect_uri:e,scope:this.scope,code:t}).then(e=>{try{if(e.id_token){const t=e.id_token.split('.'),o=Buffer.from(t[1],'base64');e.id_token=JSON.parse(o.toString())}else e.id_token={},e.id_token_error='id_token is not found'}catch(t){e.id_token_error=t.message}return e})}async refreshToken(e){return this.oauth.accessToken.create(e).refresh()}async getProfile(e){const t=new MicrosoftClient(e.access_token),o=e.id_token,n=await t.profile();let r=null;const i=await t.photo().then(e=>{if(!e)return null;const o=e['@odata.mediaContentType'],r=e.id;return t.photoImage(r).then(e=>this.FileService.enabled()?this.FileService.upload('/user/profile/microsoft/'+n.id,e,o):this.FileService.save(this.domain,e,o,'/External/Microsoft/ProfileImages',n.id,!0))});r=i&&i.url?i.url:null;let s=[],p=null,d=null,a=null,l=!1;if(o.email?p=o.email:n.mail&&(p=n.mail),n.userPrincipalName&&!p&&(p=n.userPrincipalName),p){const e=p.split('@');2===e.length&&(d=e[0],a=e[1],0<=this.certifiedEmails.indexOf(a)&&(l=!0))}return p&&l&&s.push({type:'email',value:p}),{uid:n.id,provider:'microsoft',providerProtocol:'oauth2',providerData:e,identities:s,username:d,domain:a,email:p,emailCertified:l,mobile:n.mobilePhone,mobileCertified:!1,displayName:n.displayName,displayImageURL:r,familyName:n.surname,givenName:n.givenName,gender:null,dob:null,status:null,bio:null,homepage:null,locale:n.preferredLanguage}}},__decorate([web.singleton(),__metadata('design:type',FileService)],exports.MicrosoftAuthenticator.prototype,'FileService',void 0),exports.MicrosoftAuthenticator=__decorate([web.service()],exports.MicrosoftAuthenticator),exports.SessionService=class e extends web.Resolvable{async Terminate(e,t){return SessionMutations.TerminateSession(e,t).then(t=>(t||e.warn({identity:{user:e.identity.user,session:e.identity.session}},`SessionService.terminate(): Session not found or already terminated`),t),t=>(e.error(t),null))}async CreateNew(e,t,o,n,r,i){return this.throwErrorForInvalidUser(t),SessionMutations.CreateSession(e,t,n,o,r,i)}throwErrorForInvalidUser(e){if(!e)throw new web.AuthenticationError('user not found');else if(e.deleted)throw new web.AuthenticationError(`user has been deleted at ${e.deletedAt}`);else if(e.blocked)throw new web.AuthenticationError(`user has been blocked at ${e.blockedAt}`)}throwErrorForInvalidSession(e){if(!e)throw new web.AuthenticationError('session not found');else if(e.deleted)throw new web.AuthenticationError(`session has been deleted at ${e.deletedAt}`);else if(e.blocked)throw new web.AuthenticationError(`session has been blocked at ${e.blockedAt}`);else if(e.expires<new Date)throw new web.AuthenticationError(`session has been expired at ${e.expires}`)}},exports.SessionService=__decorate([web.service()],exports.SessionService),exports.WebAuthenticationService=class e extends web.Resolvable{async Login(e,t,o=['user','admin']){const n=e.identity,r=e.domain,i=e.fingerprint();if(!n.id)throw new Error('Cookies is required for user authentication');let s;if(n.session){const n=await this.SessionService.Terminate(r,'new login');n&&(e.logger.debug({session:n._id},'Automatically logged out previous session for new user login'),s=await this.SessionService.CreateNew(r,t,i,o,n))}return s||(s=await this.SessionService.CreateNew(r,t,i,o)),this.updateWebIdentity(e,s,t),s}updateWebIdentity(e,t,o){this.IdentityService.update(e,{session:t._id,user:t.user,token:t.token,roles:t.roles,groups:[],scope:[],profile:{_id:o._id,displayName:o.displayName,displayImageURL:o.displayImageURL}})}},__decorate([core.singleton(),__metadata('design:type',exports.WebIdentityService)],exports.WebAuthenticationService.prototype,'IdentityService',void 0),__decorate([core.singleton(),__metadata('design:type',exports.SessionService)],exports.WebAuthenticationService.prototype,'SessionService',void 0),exports.WebAuthenticationService=__decorate([core.service()],exports.WebAuthenticationService);class EmailGetters{static async GetById(e,t){const o=e.collection(EmailCollection);return o.findOne({_id:mongodb.CreateObjectId(t)})}static async GetByEmailAddress(e,t){const o=e.collection(EmailCollection);return o.findOne({name:t})}}exports.UserService=class e extends web.Resolvable{findById(e,t){if(null==t)throw new TypeError('id is required');return UserGetters.GetUserById(e,t)}async findByEmail(e,t){if(!t)throw new TypeError('email is required');const o=await EmailGetters.GetByEmailAddress(e,t);return o&&o.user?UserGetters.GetUserById(e,o.user):null}CreateFromExternalUser(e,t){return UserMutations.CreateFromExternalUser(e,t)}},exports.UserService=__decorate([core.service()],exports.UserService),exports.ExternalUserService=class e extends web.Resolvable{findOrCreateExternalUser(e,t){return ExternalUserMutations.FindOrCreateExternalUser(e,t)}},exports.ExternalUserService=__decorate([core.service()],exports.ExternalUserService);var Fetch_1;let Fetch=Fetch_1=class e extends WebFoundationUserService{fetch(){const{url:e,init:t}=Fetch_1.parseFetchArguments(arguments),o={};if(e)t?t&&(o.method=t.method,o.url=e,o.data=t.data):(o.method='get',o.url=e);else if(t)o.method=t.method,o.url=t.url,o.data=t.data;else throw new Error('Invalid fetch parameters');return o.headers=this.buildAuthorisedHeaders(e,t),axios(o).then(e=>(this.addResponseHeader('Server-Timing',e.headers['Server-Timing']),e.data?(e.data.headers=e.headers,e.data):{ok:!1,headers:e.headers,status:e.status,message:e.statusText}))}static parseFetchArguments(e){const t=e.length-1;let o,n;for(let r=0;r<=t;r++)if(!o&&'string'==typeof e[r])o=e[r];else if(!n&&'object'==typeof e[r])n=e[r];else break;return{url:o,init:n}}buildAuthorisedHeaders(e,t){return{Authorization:'Bearer '+this.domain.token,"User-Agent":this.getRequestHeader('User-Agent'),"X-Request-Id":this.domain.context().req_id}}};Fetch=Fetch_1=__decorate([web.service()],Fetch);class WebFoundationContextDomain{constructor(e){this.ctx=e}get identity(){return this.ctx.identity}get resolver(){return this.ctx}get db(){return this.ctx.state.db}get settings(){return this.ctx.settings}get logger(){return this.ctx.logger}get token(){return this.ctx.identity.id}construct(e,t){return this.ctx.construct(e,t)}resolve(e,t){return this.ctx.resolve(e,t)}collection(e){return this.db.collection(e)}trace(e,t,...o){this.logger.trace.apply(this.logger,arguments)}debug(e,t,...o){this.logger.debug.apply(this.logger,arguments)}log(e,t,...o){this.logger.log.apply(this.logger,arguments)}info(e,t,...o){this.logger.info.apply(this.logger,arguments)}warn(e,t,...o){this.logger.warn.apply(this.logger,arguments)}error(e,t,...o){this.logger.error.apply(this.logger,arguments)}fatal(e,t,...o){this.logger.fatal.apply(this.logger,arguments)}child(e){return this.logger.child(e)}update(e){return this.logger.update(e)}context(){return this.logger.context()}fetch(){return this.resolve(Fetch).then(e=>e.fetch.apply(e,arguments))}has(e){return Reflect.has(this.ctx.settings,e)}set(e,t){return this.ctx.set(e,t)}}var _a;class WebFoundationController extends web.WebController{async[_a=Symbol('Upgrade')](e,t){if(e.domain=new WebFoundationContextDomain(e),e.identity&&e.identity.profile){const t=e.identity.profile;t&&t._id&&t._id.toString&&e.req.logger.update({uid:t._id.toString()})}return e.settings.MONGODB_URL&&(e.logger.info('Resolve Graph'),e.state.db=await e.resolve(Graph)),t().then(t=>(e.releaseSingleton(Graph),delete e.domain,t))}async getFailureURL(e,t){if(e.settings.WEBAPP_LOGIN_FAILED_PATH){const o=e.res.get('X-Request-Id')||'',n={req_id:o,message:t.message};return e.logger.warn(t,'Redirect to error page'),e.settings.WEBAPP_LOGIN_FAILED_PATH+'?'+querystring.stringify(n)}throw new web.Exception(t,'"WEBAPP_LOGIN_FAILED_PATH" is not set')}}__decorate([web.middleware(),__metadata('design:type',Function),__metadata('design:paramtypes',[Object,Function]),__metadata('design:returntype',Promise)],WebFoundationController.prototype,_a,null);class OAuthController extends WebFoundationController{async __OAuthController_Start(e){let t;try{const o=await this.authenticator(e),n=url.resolve(e.publicUrl,'callback');t=o.getAuthorizeURL(n,Date.now())}catch(o){t=await this.getFailureURL(e,new web.Exception(o,'Unable to start authentication'))}e.redirect(t)}async __OAuthController_Callback(e){const t=await this.authenticator(e),o=url.resolve(e.publicUrl,'callback'),n=+e.query.state,r=new WebFoundationContextDomain(e);if(n>Date.now()||n<Date.now()-3e5)return void e.redirect(t.getFailureURL(new Error('Invalid Authentication State')));if(e.query.error){const o=new Error(`${e.query.error}: ${e.query.error_description}`);e.logger.error(o,'Authentication Error'),e.redirect(t.getFailureURL(o))}try{const n=e.query.code,i=await t.getToken(o,n),s=await t.getProfile(i),p=await this.ExternalUserService.findOrCreateExternalUser(r,s);let d=p.user?await this.UserService.findById(r,p.user):null;const a=e.state.user,l=await this.callback(e,p,d,a);e.redirect(t.getSuccessURL(l))}catch(o){e.logger.error(o,'Authentication Callback Error'),e.redirect(t.getFailureURL(o))}}}__decorate([web.singleton(),__metadata('design:type',exports.ExternalUserService)],OAuthController.prototype,'ExternalUserService',void 0),__decorate([web.singleton(),__metadata('design:type',exports.UserService)],OAuthController.prototype,'UserService',void 0),__decorate([web.method('GET','/start'),__metadata('design:type',Function),__metadata('design:paramtypes',[Object]),__metadata('design:returntype',Promise)],OAuthController.prototype,'__OAuthController_Start',null),__decorate([web.method('GET','/callback'),__metadata('design:type',Function),__metadata('design:paramtypes',[Object]),__metadata('design:returntype',Promise)],OAuthController.prototype,'__OAuthController_Callback',null);class MicrosoftOAuthController extends OAuthController{async authenticator(e){if(!e.settings.OAUTH_MICROSOFT)throw new web.AuthenticationError('OAuth for Microsoft AD is not been enabled',501);else{const t=await this.configure(e),o=await e.resolve(exports.MicrosoftAuthenticator,!0);return o.init(t),o}}}exports.SYSTEM_MAX_UPLOAD_SIZE=15728640,exports.SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER=1,exports.WebFoundationApplication=WebFoundationApplication,exports.WebFoundationApplicationSettings=WebFoundationApplicationSettings,exports.Graph=Graph,exports.EmailCollection=EmailCollection,exports.ExternalUserCollection=ExternalUserCollection,exports.SessionCollection=SessionCollection,exports.UserCollection=UserCollection,exports.CurrentUser=CurrentUser,exports.ExternalUserMutations=ExternalUserMutations,exports.SessionMutations=SessionMutations,exports.UserMutations=UserMutations,exports.ExternalUserGetters=ExternalUserGetters,exports.SessionGetters=SessionGetters,exports.UserGetters=UserGetters,exports.RestClient=RestClient,exports.MicrosoftClient=MicrosoftClient,exports.MicrosoftOAuthController=MicrosoftOAuthController,exports.WebFoundationController=WebFoundationController;
//# sourceMappingURL=index.js.map
